c      common /fgrav_in/  dens(62500),ztop(62500),zbot(62500),nx,ny,
       common /fgrv_in/  dens(6400),ztop(6400),zbot(6400),nx,ny,
     &                   naugx,naugy,dx,dy,zh,nstop,err2,lulist
c      common /fgrav_out/ anom(62500)
       common /fgrv_out/ anom(6400)
c      common/grdblk/grid(262144),ncol,nrow,col1,dcol,row1,drow,
       common/grdblk/grid(25600), ncol,nrow,col1,dcol,row1,drow,
     &              iproj,cmer,blat
      character*1 yntop,ynbot,ynden,yn_ask,answer
      parameter (dvaltest=1.e37)
      index(i,j,ncol)=(j-1)*ncol+i
c
c  --  Provide user information 
c
      write(6,101)
  101 format(/,' PROGRAM PFGRAV3D -- Version 1',//,
     &         ' Computes a standard grid of gravity anomalies',
     &         ' due to topographic source.',//
     &         ' USERS BEWARE...PFGRAV3D is not well tested as',
     &         ' of 6/11/86'/)
      answer=yn_ask(' Info [y/n] ? ')
      if(answer.eq.'y')write(6,100)
  100 format(
     &/,' ************************************************************',
     &/,' Program PFGRAV3D computes a standard grid of gravity',
     &/,' anomalies due to a mass distribution described by 3 two-',
     &/,' dimensional functions:  The top surface of the mass, the',
     &/,' bottom surface, and the density.  These 3 functions can be',
     &/,' provided to PFGRAV3D either as standard grids or as single',
     &/,' constants (suitable for a flat bottom, for example).  Dvals',
     &/,' are not allowed.  The dimensions of each grid must be the',
     &/,' same; it is assumed that the corners and sample intervals',
     &/,' also agree.  Remember, PFGRAV3D wants the z-axis directed',
     &/,' down, so that hills are minima and valleys are maxima; if',
     &/,' your topographic grids do not conform to this requirement,',
     &/,' PFGRAV3D will give you an opportunity to correct them.',
     &//,' For further information, see the comments in the source',
     &/,' listing of subroutine FGRAV3D or Open-File Report 81-298.',
     &/,' **********************************************************'//)
c
c  --  Get top surface standard grid or get single constant
c
      yntop=yn_ask(' Is top surface a standard grid [y/n] ? ')
      if(yntop.eq.'y')then
         call getfile(10,' Filename = ? ','in','unformatted')
         call rdgrid(10)
         ncolsave=ncol
         nrowsave=nrow
         ntotal=ncol*nrow
         iflag=0
         do 5 i=1,ntotal
    5    if(grid(i).gt.dvaltest)iflag=1
         if(iflag.eq.1)then
            write(6,106)
  106       format(/,' ** ERROR...Dvals are not allowed')
            stop
            end if
         call eqgrid(ztop,ny,nx,1)
         conv=float_ask
     &        (' Factor to convert grid values to km, z-axis down = ? ')
         conv=conv*100000.
         do 1 i=1,ntotal
    1    ztop(i)=conv*ztop(i)
         close(10)
         else
            topconst=float_ask
     &        (' Elevation (in km, z-axis down) of top surface = ? ')
            topconst=topconst*100000.
            end if
c
c  --  Get bottom surface standard grid or get single constant
c
      ynbot=yn_ask(' Is bottom surface a standard grid [y/n] ? ')
      if(ynbot.eq.'y')then
         call getfile(10,' Filename = ? ','in','unformatted')
         call rdgrid(10)
         ntotal=ncol*nrow
         iflag=0
         do 6 i=1,ntotal
    6    if(grid(i).gt.dvaltest)iflag=1
         if(iflag.eq.1)then
            write(6,106)
            stop
            end if
c
c  --  If both top and bottom are standard grids, check for compatibility
c
         if(yntop.eq.'y')then
            if(ncol.ne.ncolsave.or.nrow.ne.nrowsave)then
               write(6,102)
  102          format(/,' ** ERROR...Incompatible standard grids')
               stop
               end if
            else
               ncolsave=ncol
               nrowsave=nrow
               end if
         call eqgrid(zbot,ny,nx,1)
         conv=float_ask
     &       (' Factor to convert grid values to km, z-axis down = ? ')
         conv=conv*100000.
         do 2 i=1,ntotal
    2    zbot(i)=conv*zbot(i)
         close(10)
         else
            botconst=float_ask
     &     (' Elevation (in km, z-axis down) of bottom surface = ? ')
            botconst=botconst*100000.
            end if
c
c  --  Get standard grid of density values or get single constant
c
      ynden=yn_ask(' Is density a standard grid [y/n] ? ')
      if(yntop.eq.'n'.and.ynbot.eq.'n'.and.ynden.eq.'n')then
         write(6,103)
  103    format(' ** ERROR...At least one standard grid is required')         
         stop
         end if
      if(ynden.eq.'y')then
         call getfile(10,' Filename = ? ','in','unformatted')
         call rdgrid(10)
         ntotal=ncol*nrow
         iflag=0
         do 7 i=1,ntotal
    7    if(grid(i).gt.dvaltest)iflag=1
         if(iflag.eq.1)then
            write(6,106)
            stop
            end if
c
c  --  Check for grid compatibility
c
         if(yntop.eq.'y'.or.ynbot.eq.'y')then
            if(ncol.ne.ncolsave.or.nrow.ne.nrowsave)then
               write(6,102)
               stop
               end if
            end if
         call eqgrid(dens,ny,nx,1)
         conv=float_ask(' Factor to convert grid values to g/cc = ? ')
         do 3 i=1,ntotal
    3    dens(i)=conv*dens(i)
         close(10)
         else
            denconst=float_ask(' Uniform density (in g/cc) = ? ')
            end if
c
c  --  Construct constant grids
c
      if(yntop.eq.'n')then
         do 4 i=1,ntotal
    4    ztop(i)=topconst
         end if
      if(ynbot.eq.'n')then
         do 8 i=1,ntotal
    8    zbot(i)=botconst
         end if
      if(ynden.eq.'n')then
         do 9 i=1,ntotal
    9    dens(i)=denconst
         end if
c
c  --  Get other needed parameters
c
      nx=nrow
      ny=ncol
      dx=drow
      dy=dcol
      write(6,104)dcol,drow
  104 format(/,' DCOL = ',g11.4,/,' DROW = ',g11.4/)
      conv=float_ask(' Factor to convert DCOL and DROW to km = ? ')
      dx=conv*dx*100000.
      dy=conv*dy*100000.
      zh=float_ask(' Altitude (in km, z-axis down) of survey = ? ')
      zh=zh*100000.
      call fftdims(ny,nx)
      naugy=int_ask(' Expanded number of columns = ? ')
      naugx=int_ask(' Expanded number of rows = ? ')
      naugx=naugx-nx
      naugy=naugy-ny
      nstop=int_ask(' Maximum number of iterations to attempt = ? ')
      err2=float_ask(' Error criterion (.001 is suggested) = ? ')
      lulist=6
c
c  --  call fgrav3d
c
      call fgrav3d
c
c  --  Move fgrav3d results into grdblk common; output results
c
      ncol=ny
      nrow=nx
      call eqgrid(anom,ny,nx,2)
      call getfile(10,' Output filename = ? ','out','unformatted')
      call wrgrid(10)
      stop
      end
c
c *** USERS BEWARE...FGRAV3D IS NOT WELL TESTED AS OF 5/15/85- RJB ***
c
      subroutine fgrav3d
c
c.........................................................................
c
c     Subroutine fgrav3d computes a rectangular grid of anomaly values, h(x,y),
c  from three rectangular grids which define the distribution of mass:
c  the top surface, ztop(x,y); the bottom surface, zbot(x,y); and
c  the density, s(x,y).  The corners and sample intervals of each
c  of these four grids are assumed to be the same.
c
c  Algorithm
c
c    The method is described by R. L. Parker (Geophysical Journal, v. 31,
c  p. 447, 1973).  It solves the summation
c
c
c                     m
c         h = IF[B * SUM( A * F[s * (zbot**n - ztop**n)])]
c                    n=0
c
c
c  where F and IF denote two-dimensional Fourier transforms and inverse
c  transforms, respectively.  The summation is continued until sufficient
c  convergence occurs.  The rate of convergence depends on the elevation of
c  the origin with respect to the magnetic body and the level of optimum
c  convergence changes at different parts of the algorithm.  Thus upward
c  and downward continuation occurs many times in the course of a run.
c
c  Input
c
c     Although the arrays h, ztop, zbot, and s are singly dimensioned, they
c  nevertheless represent two-dimensional arrays.  These increase first along
c  the y axis and then along the x axis.  For example,
c
c
c      x axis
c
c        ^
c        |
c        |
c      s((nx-1)*ny+1)..........................s(nx*ny)
c        .                                       .
c        .                                       .
c        .                                       .
c        .                                       .
c      s(ny+1)       s(ny+2)       s(ny+3) ... s(ny+nx)
c      s(1)          s(2)          s(3)    ... s(ny)     --->  y axis
c
c
c
c  All of the input arrays and parameters are supplied to fmag3d through
c  labeled common.  An itemized list follows:
c
c     s      - The array of density values
c     ztop   - The array representing the top surface
c     zbot   - The array representing the bottom surface
c     nx     - The number of array elements in the x direction
c     ny     - The number of array elements in the y direction
c     naug   - The number of rows and columns to add to the input arrays
c     dx     - the sample interval of the arrays in the x direction
c     dy     - the sample interval of the arrays in the y direction
c     zh     - the elevation of the survey
c     nstop  - the limit of summations, if convergence does not occur
c     err2   - the definition of convergence (see note below)
c     lulist - the logical unit number to receive printed output
c
c
c  Units
c
c     The units of distance for zbot, ztop, dx, dy, and zh are centimeters.
c  in the usual way.  The unit of density for s is g/cc.
c
c  Output
c
c     The only output is the arrays h, the gravity anomaly in units of mgals.
c
c
c  Notes
c
c     1 - Convergence is assumed to occur when the absolute value of the
c         nth term is err2 times the absolute value of the sum of all previous 
c         terms.  A typical value for err2 is .001
c     2 - Subroutine fmag3d calls a fast-Fourier transform subroutine called
c         fft written by R.C. Singleton (IEEE Trans. Audio Electroac., v.
c         AU-17, p. 93, 1969).  Subroutine fft is faster if the size of the
c         array being transformed can be factored into many small prime
c         numbers, and in fact certain dimensions are not permitted by fft
c         (see the documentation in fft for details).  Because the arrays
c         being sent to fmag3d are not necessarily going to have optimal
c         dimensions, a facility is available to augment rows and columns.
c         The number of rows and columns added are naug; the elements are
c         calculated so as to make the arrays more periodic thus reducing
c         edge effect problems.  These additional rows and columns are
c         discarded by fmag3d before sending results back to the calling
c         program.
c
c     3 - For further information, see the paper, 'A program for rapidly
c         computine the magnetic anomaly over digital topography', USGS
c         open file report, 1981, by R. J. Blakely.
c
c.........................................................................
c
c      common /fgrav_in/  s(62500),ztop(62500),zbot(62500),nx,ny,
       common /fgrv_in/  s(6400),ztop(6400),zbot(6400),nx,ny,
     &                   naugx,naugy,dx,dy,zh,nstop,err2,lulist
c      common /fgrav_out/ h(62500)
       common /fgrv_out/ h(6400)
c      common /inter1/    work1(250,250),work2(250,250)
       common /inter1/    work1(80,80),work2(80,80)
c      common /inter3/    fcmplx(62500)
       common /inter3/    fcmplx(6400)
c      common /inter2/    sum(62500),k(62500),kx(250),ky(250),fact(31)
       common /inter2/    sum(6400),k(6400),kx(80),ky(80),fact(31)
c      common /inter4/    hcmplx(62500),expbot(62500),exptop(62500)
       common /inter4/    hcmplx(6400),expbot(6400),exptop(6400)
       complex sum,hcmplx,fcmplx ,tmp
      real kx,ky,k
      character*3 mode
      data twopi/6.2831853/,epslon/.1e-10/,G/6.670e-8/,
     &     gal_to_mgal/1.e3/
      index(i,j,ny)=(i-1)*ny+j
c.........................................................................
c  --  Augment the arrays to reduce edge effects and speed up fft
c.........................................................................
      if(naugx.eq.0.and.naugy.eq.0)go to 17
      call augment(s,ny,nx,naugy,naugx,1)
      call augment(ztop,ny,nx,naugy,naugx,1)
      call augment(zbot,ny,nx,naugy,naugx,1)
      nx=nx+naugx
      ny=ny+naugy
   17 continue
c......................................................................
c  --  Initialize a few parameters
c......................................................................
      do 22 i=1,nstop
      fact(i)=1./fac(i,ier)
   22 continue
      dkx=twopi/(nx*dx)
      dky=twopi/(ny*dy)
      ntotal=nx*ny
      nnx=nx/2+1
      nny=ny/2+1
c......................................................................
c  --  Initialize the wavenumber coordinates
c......................................................................
      do 3 i=1,nx
      if(i-nnx)4,4,5
    4 kx(i)=(i-1)*dkx
      go to 3
    5 kx(i)=(i-nx-1)*dkx
    3 continue
      do 6 j=1,ny
      if(j-nny)7,7,8
    7 ky(j)=(j-1)*dky
      go to 12
    8 ky(j)=(j-ny-1)*dky
   12 continue
      sky=ky(j)**2
      do 6 i=1,nx
      ij=index(i,j,ny)
      k(ij)=sqrt(kx(i)**2+sky)
    6 continue
c......................................................................
c  --  Find maxima and minima of ztop and zbot arrays; fixup bad values
c      of ztop and zbot
c......................................................................
      ztpmax=-.1e20
      ztpmin= .1e20
      zbtmax=-.1e20
      zbtmin= .1e20
      nerr1=0
      nerr2=0
      do 1 i=1,ntotal
      if(ztop(i).gt.(zh+epslon))go to 10
      nerr2=nerr2+1
      ztop(i)=zh+epslon
   10 continue
      if(ztop(i).lt.zbot(i))go to 2
      zbot(i)=ztop(i)
      nerr1=nerr1+1
    2 continue
      ztpmax=amax1(ztpmax,ztop(i))
      ztpmin=amin1(ztpmin,ztop(i))
      zbtmax=amax1(zbtmax,zbot(i))
      zbtmin=amin1(zbtmin,zbot(i))
    1 continue
      if(nerr1.gt.0)write(lulist,100)nerr1
  100 format(/,' **WARNING  - THE BODY HAS NEGATIVE THICKNESS AT ',
     &    i6,/,'              POINTS.  BODY WILL HAVE ZERO THICKNESS',
     &       /,'              AT THESE LOCATIONS.'/)
      if(nerr2.gt.0)write(lulist,106)nerr2
  106 format(/,' **WARNING  - BODY RISES ABOVE SURVEY ELEVATION AT ',
     &    i6,/,'              POINTS.  BODY WILL BE TRUNCATED',
     &       /,'              ACCORDINGLY.'/)
c......................................................................
c  --  Find median values for ztop and zbot; determine if either are flat
c......................................................................
      iflttp=0
      ifltbt=0
      if(ztpmax.eq.ztpmin)iflttp=1
      if(zbtmax.eq.zbtmin)ifltbt=1
      ztpmed=ztpmin+(ztpmax-ztpmin)/2.
      zbtmed=zbtmin+(zbtmax-zbtmin)/2.
      write(lulist,108)ztpmin,ztpmax,ztpmed,zbtmin,zbtmax,zbtmed
  108 format(/,' HIGH, LOW, AND MEDIAN POINTS OF TOPOGRAPHY ARE ',//,
     &  3g11.4,///,' THE HIGH, LOW, AND MEDIAN POINTS OF THE BOTTOM',
     &  ' SURFACE ARE ',//,3g11.4/)
c......................................................................
c  --  Find the upward continuation arrays, adjust surfaces to median levels,
c      and make the magnetization complex
c......................................................................
      iflag1=0
      iflag2=0
      do 11 i=1,ntotal
      sum(i)=0.
      arg1=-k(i)*(ztpmed-zh)
      arg2=-k(i)*(zbtmed-zh)
      if(arg1+88.028)30,31,31
   30 iflag1=iflag1+1
      exptop(i)=0.
      go to 32
   31 exptop(i)=exp(arg1)
   32 continue
      if(arg2+88.028)33,34,34
   33 iflag2=iflag2+1
      expbot(i)=0.
      go to 35
   34 expbot(i)=exp(arg2)
   35 continue
      ztop(i)=ztop(i)-ztpmed
      zbot(i)=zbot(i)-zbtmed
      fcmplx(i)=s(i)
   11 continue
c......................................................................
c  --  Report problems with upward continuation
c......................................................................
      if(iflag1.gt.0)write(lulist,111)iflag1
  111 format(/,' **WARNING - UPWARD CONTINUATION EXPONENTIAL FOR',
     &       /,'             UPPER SURFACE UNDERFLOWS ',i6,' TIMES',
     &       /,'             AND THESE WILL BE MADE ZERO.'/)
      if(iflag2.gt.0)write(lulist,112)iflag2
  112 format(/,' **WARNING - UPWARD CONTINUATION EXPONENTIAL FOR',
     &       /,'             LOWER SURFACE UNDERFLOWS ',i6,' TIMES',
     &       /,'             AND THESE WILL BE MADE ZERO.'/)
c......................................................................
c  --  Do the n=0 term because its simple
c......................................................................
      call fftsub(work1,work2,nx,ny,-1)
      do 29 i=2,ntotal
      hcmplx(i)=-fcmplx(i)*(expbot(i)-exptop(i))/k(i)
   29 continue
      hcmplx(1)=-fcmplx(1)*(ztpmed-zbtmed)
c......................................................................
c  --  Get ready for summation
c......................................................................
      write(lulist,110)err2
  110 format(/,' PERFORMANCE OF SUMMATION',/,
     &  ' TRYING TO REACH ',f5.3,' OF STOTAL'/)
      write(lulist,101)
  101 format(/,4x,'N',4x,'STOTAL',5x,'SLAST',4x,'SRATIO'/)
c......................................................................
c  --  Begin summations
c......................................................................
      n=0
   14 n=n+1
c......................................................................
c  --  Combine upper surface with density and Fourier transform; if upper
c      is flat, skip this step
c......................................................................
      if(iflttp.eq.1)go to 13
      do 21 i=1,ntotal
      fcmplx(i)=s(i)*ztop(i)**n
   21 continue
      call fftsub(work1,work2,nx,ny,-1)
c......................................................................
c  --  Multiply by upward continuation array
c......................................................................
      do 15 i=1,ntotal
      sum(i)=-exptop(i)*fcmplx(i)
   15 continue
   13 continue
c......................................................................
c  --  Combine lower surface with density and Fourier transform; if lower
c      surface is flat, skip this step
c......................................................................
      if(ifltbt.eq.1)go to 16
      do 24 i=1,ntotal
      fcmplx(i)=s(i)*zbot(i)**n
   24 continue
      call fftsub(work1,work2,nx,ny,-1)
c......................................................................
c  --  Multiply by upward continuation array and add to previous result for
c      upper surface
c......................................................................
      do 23 i=1,ntotal  
c      sum(i)=expbot(i)*fcmplx(i)+sum(i)  changed for pc 12-15-88 mrm
        tmp = expbot(i)*fcmplx(i)
        sum(i) = tmp+sum(i)
   23 continue
   16 continue
c......................................................................
c  --  Multiply this term by -k**n/n! and find its contribution; find the
c      contribution of the sum of all previous terms; add the new term
c......................................................................
      slast=0.
      stotal=0.
      do 26 i=1,ntotal
      if(n.ne.1.or.i.ne.1)go to 20
      arg=1.
      go to 26
   20 continue
      arg=((-k(i))**(n-1))*fact(n)
      sum(i)=arg*sum(i)
      slast=slast+cabs(sum(i))
      stotal=stotal+cabs(hcmplx(i))
      hcmplx(i)=hcmplx(i)+sum(i)
   26 continue                                     
      slast=slast/ntotal
      stotal=stotal/ntotal
      stest=err2*stotal
      sratio=slast/(stotal+.1e-20)
c......................................................................
c  --  check for convergence of sum
c......................................................................
      write(lulist,104)n,stotal,slast,sratio
  104 format(i5,3g10.3)
      if(n.lt.nstop.and.slast.ge.stest)go to 14
c......................................................................
c  --  Summation has converged; multiply by G and inverse Fourier transform
c......................................................................
      factor=twopi*G*gal_to_mgal
      do 9 j=1,ny
      do 9 i=1,nx
      ij=index(i,j,ny)
      fcmplx(ij)=hcmplx(ij)*factor
    9 continue
      call fftsub(work1,work2,nx,ny,1)
c......................................................................
c  --  Put real part of complex anomaly back into real array
c......................................................................
      do 19 i=1,ntotal
      h(i)=fcmplx(i)/ntotal
   19 continue
c......................................................................
c  --  Unaugment the arrays
c......................................................................
      if(naugx.eq.0.and.naugy.eq.0)go to 18
      nx=nx-naugx
      ny=ny-naugy
      call augment(h,ny,nx,naugy,naugx,0)
   18 continue
      return
      end
      function fac(n,ier)
c
c.........................................................................
c
c  Function fac finds the factorial of n
c
c.........................................................................
c
      ier=0
      if(n.gt.1)go to 10
      if(n.ge.0)go to 20
      ier=1
   20 fac=1.
      return
   10 fac=n
      fac2=fac
   30 fac2=fac2-1.
      if(fac2.eq.1.)return
      fac=fac*fac2
      go to 30
      end
      subroutine augment(f[huge],ncol,nrow,naugcol,naugrow,iadd)
c      dimension f(62500)
       dimension f(6400)
c      common /inter5/temp(62500)
       common /inter5/temp(6400)
c
c..........................................................................
c
c     Subroutine augment adds or subtracts naugcol columns and naugrow
c  rows to or from array f.  If iadd=1, the new array f has dimensions
c  (ncol+naugcol) X (nrow+naugrow) and the new
c  values added to f are calculated to be straight-line slopes so as to
c  make f periodic.  For example, if f(2,1)=4, f(2,nrow)=0, and naugrow=3, then
c  f(2,nrow+1)=3, f(2,nrow+2)=2, and f(2,nrow+3)=1.
c     if iadd=0, subroutine augment takes an array f of dimensions
c  (ncol+naugcol) X (nrow+naugrow) and strips off the last naugcol columns
c  and naugrow rows to leave f with dimensions ncol X nrow.
c
c..........................................................................
c
      index(i,j,n)=(i-1)*n+j
      nrp1=nrow+1
      ncp1=ncol+1
      nrpna=nrow+naugrow
      ncpna=ncol+naugcol
      if(iadd.eq.0)go to 9
      do 1 i=1,nrow
      ij1=index(i,1,ncol)
      ij2=index(i,ncol,ncol)
      discon=(f(ij2)-f(ij1))/(naugcol+1)
      do 2 j=1,ncol
      ij3=index(i,j,ncol)
      ij4=index(i,j,ncpna)
    2 temp(ij4)=f(ij3)
      do 3 j=ncp1,ncpna
      ij4=index(i,j,ncpna)
    3 temp(ij4)=f(ij2)-discon*(j-ncol)
    1 continue
      do 4 j=1,ncpna
      ij1=index(1,j,ncpna)
      ij2=index(nrow,j,ncpna)
      discon=(temp(ij2)-temp(ij1))/(naugrow+1)
      do 5 i=nrp1,nrpna
      ij=index(i,j,ncpna)
    5 temp(ij)=temp(ij2)-discon*(i-nrow)
    4 continue
      do 6 i=1,nrpna
      do 6 j=1,ncpna
      ij=index(i,j,ncpna)
    6 f(ij)=temp(ij)
      return
c
    9 continue
      do 7 i=1,nrow
      do 7 j=1,ncol
      ij1=index(i,j,ncol)
      ij2=index(i,j,ncpna)
    7 temp(ij1)=f(ij2)
      do 8 i=1,nrow
      do 8 j=1,ncol
      ij=index(i,j,ncol)
    8 f(ij)=temp(ij)
      return
      end
      subroutine fftsub(work1,work2,nx,ny,isign)
      dimension work1(ny,nx),work2(ny,nx)
c      common /inter3/fcmplx(62500)
       common/inter3/fcmplx(6400)
      complex fcmplx,cmplx
c
c.......................................................................
c
c  --     This routine splits a complex array fcmplx into its real and
c      imaginary parts, calls Singleton's subroutine fft, and puts the
c      results back into fcmplx
c
c........................................................................
c
      index(i,j,n)=(i-1)*n+j
      ntotal=nx*ny
      do 1 i=1,nx
      do 1 j=1,ny
      ij=index(i,j,ny)
      work1(j,i)=real(fcmplx(ij))
      work2(j,i)=aimag(fcmplx(ij))
    1 continue
      call fft(work1,work2,ntotal,ny,ny,isign)
      call fft(work1,work2,ntotal,nx,ntotal,isign)
      do 2 i=1,nx
      do 2 j=1,ny
      ij=index(i,j,ny)
      fcmplx(ij)=cmplx(work1(j,i),work2(j,i))
    2 continue
      return
      end
      subroutine fftdims(ncol,nrow)                                             
c     Prints out numbers less than 1024 with no prime factor greater than 5.    
c     The FFT algorithm works fastest for these numbers.                        
c     Subroutine prints out good numbers between                                
c       min of (ncol,nrow) and max of (ncol+100,nrow+100).                      
c                                                                               
      dimension nlist(104),ngood(100)                                           
c     first 2 cols from table III of Singleton's paper on fft....               
c       (Singleton,R.C., 1969, An algotithm for computing the mixed             
c          radix fast Fourier transform:  IEEE Trans., Audio and Electro-       
c          acoustics: v. AU-17, p. 93-103.                                      
c                                                                               
      data nlist/2,3,4,5,6,8,9,10,12,15,16,18,20,24,25,27,30,                   
     &   32,36,40,45,48,50,54,60,64,72,75,80,81,90,96,100,108,120,              
     &   125,128,135,144,150,160,162,180,192,200,216,225,240,                   
     &   243,250,256,270,288,300,320,324,360,375,384,400,405,432,450,           
     &   480,486,500,512,540,576,600,625,640,648,675,720,729,750,               
     &   768,800,810,864,900,960,972,1000,1024,1080,1125,1152,1200,             
     &   1215,1250,1280,1296,1350,1440,1458,1500,1536,1600,1620,1728,           
     &   1800,1875/                                                             
c                                                                               
      min=min0(ncol,nrow)                                                       
      if(min.eq.1) min=max0(ncol,nrow)                                          
      max=max0(ncol+100,nrow+100)                                               
      n=0                                                                       
      do 10 i=1,104                                                             
      if(nlist(i).lt.min) go to 10                                              
      if(nlist(i).gt.max) go to 20                                              
      n=n+1                                                                     
      ngood(n)=nlist(i)                                                         
 10   continue                                                                  
c                                                                               
 20   write(6,902)
 902  format(' Suggested values for naugx and naugy:')
      write(6,101) (ngood(i),i=1,n)                                             
 101  format('      ',14i5)                                                     
c                                                                               
      return                                                                    
      end                                                                       
c-----------------------------------------------------------------------------
      subroutine eqgrid(grid2[huge],ncol2,nrow2,iflag)
c      common/grdblk/grid(262144),ncol,nrow,col1,dcol,row1,drow,
       common/grdblk/grid(25600), ncol,nrow,col1,dcol,row1,drow,
     &              iproj,cmer,blat
      dimension grid2(1)
      if(iflag.ne.1.and.iflag.ne.2)then
         write(6,100)
  100    format(/,' **ERROR IN EQGRID')
         return
         end if
      if(iflag.eq.1)then
         ntotal=ncol*nrow
         do 1 i=1,ntotal
    1       grid2(i)=grid(i)
         ncol2=ncol
         nrow2=nrow
         end if
      if(iflag.eq.2)then
         ntotal=ncol2*nrow2
         do 2 i=1,ntotal
    2       grid(i)=grid2(i)
         ncol=ncol2
         nrow=nrow2
         end if
      return
      end
      subroutine fft(a,b,ntot,n,nspan,isn)
c ********************* start of fft *************************
c                                  up to 2/4/73
c
c  ** for real data, use together with realtr, a separate routine
c      -see realtr for details
c
c  ** does not run under watfiv
c
c  ** as an example of how to call this program,  a test driver
c          is available in a separate library
c
c  multivariate complex fourier transform, computed in place
c    using mixed-radix fast fourier transform algorithm.
c  by r. c. singleton, stanford research institute, sept. 1968
c  arrays a and b originally hold the real and imaginary
c    components of the data, and return the real and
c    imaginary components of the resulting fourier coefficients.
c  multivariate data is indexed according to the fortran
c    array element successor function, without limit
c    on the number of implied multiple subscripts.
c    the subroutine is called once for each variate.
c    the calls for a multivariate transform may be in any order.
c  ntot is the total number of complex data values.
c  n is the dimension of the current variable.
c  nspan/n is the spacing of consecutive data values
c    while indexing the current variable.
c  the sign of isn determines the sign of the complex
c    exponential, and the magnitude of isn is normally one.
c  a tri-variate transform with a(n1,n2,n3), b(n1,n2,n3)
c    is computed by
c      call fft(a,b,n1*n2*n3,n1,n1,1)
c      call fft(a,b,n1*n2*n3,n2,n1*n2,1)
c      call fft(a,b,n1*n2*n3,n3,n1*n2*n3,1)
c  for a single-variate transform,
c    ntot = n = nspan = (number of complex data values), e.g.
c      call fft(a,b,n,n,n,1)
c  the data can alternatively be stored in a single complex array c
c   in standard fortran fashion, i.e., alternating real and
c   imaginary parts.  then with most fortran compilers, the
c   complex array c can be equivalenced to a real array a, the
c   magnitude of isn changed to two to give the correct indexing
c   increment, and a and a(2) used to pass the initial addresses
c   for the sequences of real and imaginary values, e.g.,
c      complex c(ntot)
c      real a(2*ntot)
c      equivalence (c(1),a(1))
c      call fft(a,a(2),ntot,n,nspan,2)
c  arrays at(maxf), ck(maxf), bt(maxf), sk(maxf), and np(maxp)
c    are used for temporary storage.  if the available storage
c    is insufficient, the program is terminated by a stop.
c    maxf must be .ge. the maximum prime factor of n.
c    maxp must be .gt. the number of prime factors of n.
c    in addition, if the square-free portion k of n has two or
c    more prime factors, then maxp must be .ge. k-1.
        IMPLICIT REAL*8(A-H,O-Z)
        REAL*4 A,B
      dimension a(1),b(1)
c  array storage in nfac for a maximum of 15 prime factors of n.
c  if n has more than one square-free factor, the product of the
c    square-free factors must be .le. 210
      dimension nfac(11),np(209)
c  array storage for maximum prime factor of 91
      dimension at(91),ck(91),bt(91),sk(91)
      equivalence (i,ii)
c  the following two constants should agree with the array dimensions.
      maxf=91
      maxp=209
      if(n .lt. 2) return
      inc=isn
      c72=0.30901699437494742d0
      s72=0.95105651629515357d0
      s120=0.86602540378443865d0
      rad=6.2831853071796d0
      if(isn .ge. 0) go to 10
      s72=-s72
      s120=-s120
      rad=-rad
      inc=-inc
   10 nt=inc*ntot
      ks=inc*nspan
      kspan=ks
      nn=nt-inc
      jc=ks/n
      radf=rad*float(jc)*0.5
      i=0
      jf=0
c  determine the factors of n
      m=0
      k=n
      go to 20
   15 m=m+1
      nfac(m)=4
      k=k/16
   20 if(k-(k/16)*16 .eq. 0) go to 15
      j=3
      jj=9
      go to 30
   25 m=m+1
      nfac(m)=j
      k=k/jj
   30 if(mod(k,jj) .eq. 0) go to 25
      j=j+2
      jj=j**2
      if(jj .le. k) go to 30
      if(k .gt. 4) go to 40
      kt=m
      nfac(m+1)=k
      if(k .ne. 1) m=m+1
      go to 80
   40 if(k-(k/4)*4 .ne. 0) go to 50
      m=m+1
      nfac(m)=2
      k=k/4
   50 kt=m
      j=2
   60 if(mod(k,j) .ne. 0) go to 70
      m=m+1
      nfac(m)=j
      k=k/j
   70 j=((j+1)/2)*2+1
      if(j .le. k) go to 60
   80 if(kt .eq. 0) go to 100
      j=kt
   90 m=m+1
      nfac(m)=nfac(j)
      j=j-1
      if(j .ne. 0) go to 90
c  compute fourier transform
  100 sd=radf/float(kspan)
      cd=2.0*sin(sd)**2
      sd=sin(sd+sd)
      kk=1
      i=i+1
      if(nfac(i) .ne. 2) go to 400
c  transform for factor of 2 (including rotation factor)
      kspan=kspan/2
      k1=kspan+2
  210 k2=kk+kspan
      ak=a(k2)
      bk=b(k2)
      a(k2)=a(kk)-ak
      b(k2)=b(kk)-bk
      a(kk)=a(kk)+ak
      b(kk)=b(kk)+bk  
      kk=k2+kspan
      if(kk .le. nn) go to 210
      kk=kk-nn
      if(kk .le. jc) go to 210
      if(kk .gt. kspan) go to 800
  220 c1=1.0-cd
      s1=sd
  230 k2=kk+kspan
      ak=a(kk)-a(k2)
      bk=b(kk)-b(k2)
      a(kk)=a(kk)+a(k2)
      b(kk)=b(kk)+b(k2)
      a(k2)=c1*ak-s1*bk
      b(k2)=s1*ak+c1*bk
      kk=k2+kspan
      if(kk .lt. nt) go to 230
      k2=kk-nt
      c1=-c1
      kk=k1-k2
      if(kk .gt. k2) go to 230
      ak=c1-(cd*c1+sd*s1)
      s1=(sd*c1-cd*s1)+s1
      c1=2.0-(ak**2+s1**2)
      s1=c1*s1
      c1=c1*ak
      kk=kk+jc
      if(kk .lt. k2) go to 230
      k1=k1+inc+inc
      kk=(k1-kspan)/2+jc
      if(kk .le. jc+jc) go to 220
      go to 100
c  transform for factor of 3 (optional code)
  320 k1=kk+kspan
      k2=k1+kspan
      ak=a(kk)
      bk=b(kk)
      aj=a(k1)+a(k2)
      bj=b(k1)+b(k2)
      a(kk)=ak+aj
      b(kk)=bk+bj  
      ak=-0.5*aj+ak
      bk=-0.5*bj+bk
      aj=(a(k1)-a(k2))*s120
      bj=(b(k1)-b(k2))*s120
      a(k1)=ak-bj
      b(k1)=bk+aj
      a(k2)=ak+bj
      b(k2)=bk-aj
      kk=k2+kspan
      if(kk .lt. nn) go to 320
      kk=kk-nn
      if(kk .le. kspan) go to 320
      go to 700
c  transform for factor of 4
  400 if(nfac(i) .ne. 4) go to 600
      kspnn=kspan
      kspan=kspan/4
  410 c1=1.0
      s1=0
  420 k1=kk+kspan
      k2=k1+kspan
      k3=k2+kspan
      akp=a(kk)+a(k2)
      akm=a(kk)-a(k2)
      ajp=a(k1)+a(k3)
      ajm=a(k1)-a(k3)
      a(kk)=akp+ajp
      ajp=akp-ajp
      bkp=b(kk)+b(k2)
      bkm=b(kk)-b(k2)
      bjp=b(k1)+b(k3)
      bjm=b(k1)-b(k3)
      b(kk)=bkp+bjp            
      bjp=bkp-bjp
      if(isn .lt. 0) go to 450
      akp=akm-bjm
      akm=akm+bjm
      bkp=bkm+ajm
      bkm=bkm-ajm
      if(s1 .eq. 0) go to 460
  430 a(k1)=akp*c1-bkp*s1
      b(k1)=akp*s1+bkp*c1
      a(k2)=ajp*c2-bjp*s2
      b(k2)=ajp*s2+bjp*c2
      a(k3)=akm*c3-bkm*s3
      b(k3)=akm*s3+bkm*c3
      kk=k3+kspan
      if(kk .le. nt) go to 420
  440 c2=c1-(cd*c1+sd*s1)
      s1=(sd*c1-cd*s1)+s1
      c1=2.0-(c2**2+s1**2)
      s1=c1*s1
      c1=c1*c2
      c2=c1**2-s1**2
      s2=2.0*c1*s1
      c3=c2*c1-s2*s1
      s3=c2*s1+s2*c1
      kk=kk-nt+jc
      if(kk .le. kspan) go to 420
      kk=kk-kspan+inc
      if(kk .le. jc) go to 410
      if(kspan .eq. jc) go to 800
      go to 100
  450 akp=akm+bjm
      akm=akm-bjm
      bkp=bkm-ajm
      bkm=bkm+ajm
      if(s1 .ne. 0) go to 430
  460 a(k1)=akp
      b(k1)=bkp
      a(k2)=ajp
      b(k2)=bjp
      a(k3)=akm
      b(k3)=bkm
      kk=k3+kspan
      if(kk .le. nt) go to 420
      go to 440
c  transform for factor of 5 (optional code)
  510 c2=c72**2-s72**2
      s2=2.0*c72*s72
  520 k1=kk+kspan
      k2=k1+kspan
      k3=k2+kspan
      k4=k3+kspan
      akp=a(k1)+a(k4)
      akm=a(k1)-a(k4)
      bkp=b(k1)+b(k4)
      bkm=b(k1)-b(k4)
      ajp=a(k2)+a(k3)
      ajm=a(k2)-a(k3)
      bjp=b(k2)+b(k3)
      bjm=b(k2)-b(k3)
      aa=a(kk)
      bb=b(kk)
      a(kk)=aa+akp+ajp
      b(kk)=bb+bkp+bjp
      ak=akp*c72+ajp*c2+aa
      bk=bkp*c72+bjp*c2+bb
      aj=akm*s72+ajm*s2
      bj=bkm*s72+bjm*s2
      a(k1)=ak-bj
      a(k4)=ak+bj
      b(k1)=bk+aj
      b(k4)=bk-aj
      ak=akp*c2+ajp*c72+aa
      bk=bkp*c2+bjp*c72+bb
      aj=akm*s2-ajm*s72
      bj=bkm*s2-bjm*s72
      a(k2)=ak-bj
      a(k3)=ak+bj
      b(k2)=bk+aj
      b(k3)=bk-aj
      kk=k4+kspan
      if(kk .lt. nn) go to 520
      kk=kk-nn
      if(kk .le. kspan) go to 520
      go to 700
c  transform for odd factors
  600 k=nfac(i)
      kspnn=kspan
      kspan=kspan/k
      if(k .eq. 3) go to 320
      if(k .eq. 5) go to 510
      if(k .eq. jf) go to 640
      jf=k
      s1=rad/float(k)
      c1=cos(s1)
      s1=sin(s1)
      if(jf .gt. maxf) go to 998
      ck(jf)=1.0
      sk(jf)=0.0
      j=1
  630 ck(j)=ck(k)*c1+sk(k)*s1
      sk(j)=ck(k)*s1-sk(k)*c1
      k=k-1
      ck(k)=ck(j)
      sk(k)=-sk(j)
      j=j+1
      if(j .lt. k) go to 630
  640 k1=kk
      k2=kk+kspnn
      aa=a(kk)
      bb=b(kk)
      ak=aa
      bk=bb
      j=1
      k1=k1+kspan
  650 k2=k2-kspan
      j=j+1
      at(j)=a(k1)+a(k2)
      ak=at(j)+ak
      bt(j)=b(k1)+b(k2)
      bk=bt(j)+bk
      j=j+1
      at(j)=a(k1)-a(k2)
      bt(j)=b(k1)-b(k2)
      k1=k1+kspan
      if(k1 .lt. k2) go to 650
      a(kk)=ak
      b(kk)=bk
      k1=kk
      k2=kk+kspnn
      j=1
  660 k1=k1+kspan
      k2=k2-kspan
      jj=j
      ak=aa
      bk=bb
      aj=0.0
      bj=0.0
      k=1
  670 k=k+1
      ak=at(k)*ck(jj)+ak
      bk=bt(k)*ck(jj)+bk
      k=k+1
      aj=at(k)*sk(jj)+aj
      bj=bt(k)*sk(jj)+bj
      jj=jj+j
      if(jj .gt. jf) jj=jj-jf
      if(k .lt. jf) go to 670
      k=jf-j
      a(k1)=ak-bj
      b(k1)=bk+aj
      a(k2)=ak+bj
      b(k2)=bk-aj
      j=j+1
      if(j .lt. k) go to 660
      kk=kk+kspnn
      if(kk .le. nn) go to 640
      kk=kk-nn
      if(kk .le. kspan) go to 640
c  multiply by rotation factor (except for factors of 2 and 4)
  700 if(i .eq. m) go to 800
      kk=jc+1
  710 c2=1.0-cd
      s1=sd
  720 c1=c2
      s2=s1
      kk=kk+kspan
  730 ak=a(kk)
      a(kk)=c2*ak-s2*b(kk)
      b(kk)=s2*ak+c2*b(kk)
      kk=kk+kspnn
      if(kk .le. nt) go to 730
      ak=s1*s2
      s2=s1*c2+c1*s2
      c2=c1*c2-ak
      kk=kk-nt+kspan
      if(kk .le. kspnn) go to 730
      c2=c1-(cd*c1+sd*s1)
      s1=s1+(sd*c1-cd*s1)
      c1=2.0-(c2**2+s1**2)
      s1=c1*s1
      c2=c1*c2
      kk=kk-kspnn+jc
      if(kk .le. kspan) go to 720
      kk=kk-kspan+jc+inc
      if(kk .le. jc+jc) go to 710
      go to 100
c  permute the results to normal order---done in two stages
c  permutation for square factors of n
  800 np(1)=ks
      if(kt .eq. 0) go to 890
      k=kt+kt+1
      if(m .lt. k) k=k-1
      j=1
      np(k+1)=jc
  810 np(j+1)=np(j)/nfac(j)
      np(k)=np(k+1)*nfac(j)
      j=j+1
      k=k-1
      if(j .lt. k) go to 810
      k3=np(k+1)
      kspan=np(2)
      kk=jc+1
      k2=kspan+1
      j=1
      if(n .ne. ntot) go to 850
c  permutation for single-variate transform (optional code)
  820 ak=a(kk)
      a(kk)=a(k2)
      a(k2)=ak
      bk=b(kk)
      b(kk)=b(k2)
      b(k2)=bk
      kk=kk+inc
      k2=kspan+k2
      if(k2 .lt. ks) go to 820
  830 k2=k2-np(j)
      j=j+1
      k2=np(j+1)+k2
      if(k2 .gt. np(j)) go to 830
      j=1
  840 if(kk .lt. k2) go to 820
      kk=kk+inc
      k2=kspan+k2
      if(k2 .lt. ks) go to 840
      if(kk .lt. ks) go to 830
      jc=k3
      go to 890
c  permutation for multivariate transform
  850 k=kk+jc
  860 ak=a(kk)
      a(kk)=a(k2)
      a(k2)=ak
      bk=b(kk)
      b(kk)=b(k2)
      b(k2)=bk
      kk=kk+inc
      k2=k2+inc
      if(kk .lt. k) go to 860
      kk=kk+ks-jc
      k2=k2+ks-jc
      if(kk .lt. nt) go to 850
      k2=k2-nt+kspan
      kk=kk-nt+jc
      if(k2 .lt. ks) go to 850
  870 k2=k2-np(j)
      j=j+1
      k2=np(j+1)+k2
      if(k2 .gt. np(j)) go to 870
      j=1
  880 if(kk .lt. k2) go to 850
      kk=kk+jc
      k2=kspan+k2
      if(k2 .lt. ks) go to 880
      if(kk .lt. ks) go to 870
      jc=k3
  890 if(2*kt+1 .ge. m) return
      kspnn=np(kt+1)
c  permutation for square-free factors of n
      j=m-kt
      nfac(j+1)=1
  900 nfac(j)=nfac(j)*nfac(j+1)
      j=j-1
      if(j .ne. kt) go to 900
      kt=kt+1
      nn=nfac(kt)-1
      if(nn .gt. maxp) go to 998
      jj=0
      j=0
      go to 906
  902 jj=jj-k2
      k2=kk
      k=k+1
      kk=nfac(k)
  904 jj=kk+jj
      if(jj .ge. k2) go to 902
      np(j)=jj
  906 k2=nfac(kt)
      k=kt+1
      kk=nfac(k)
      j=j+1
      if(j .le. nn) go to 904
c  determine the permutation cycles of length greater than 1
      j=0
      go to 914
  910 k=kk
      kk=np(k)
      np(k)=-kk
      if(kk .ne. j) go to 910
      k3=kk
  914 j=j+1
      kk=np(j)
      if(kk .lt. 0) go to 914
      if(kk .ne. j) go to 910
      np(j)=-j
      if(j .ne. nn) go to 914
      maxf=inc*maxf
c  reorder a and b, following the permutation cycles
      go to 950
  924 j=j-1
      if(np(j) .lt. 0) go to 924
      jj=jc
  926 kspan=jj
      if(jj .gt. maxf) kspan=maxf
      jj=jj-kspan
      k=np(j)
      kk=jc*k+ii+jj
      k1=kk+kspan
      k2=0
  928 k2=k2+1
      at(k2)=a(k1)
      bt(k2)=b(k1)
      k1=k1-inc
      if(k1 .ne. kk) go to 928
  932 k1=kk+kspan
      k2=k1-jc*(k+np(k))
      k=-np(k)
  936 a(k1)=a(k2)
      b(k1)=b(k2)
      k1=k1-inc
      k2=k2-inc
      if(k1 .ne. kk) go to 936
      kk=k2
      if(k .ne. j) go to 932
      k1=kk+kspan
      k2=0
  940 k2=k2+1
      a(k1)=at(k2)
      b(k1)=bt(k2)
      k1=k1-inc
      if(k1 .ne. kk) go to 940
      if(jj .ne. 0) go to 926
      if(j .ne. 1) go to 924
  950 j=k3+1
      nt=nt-kspnn
      ii=nt-inc+1
      if(nt .ge. 0) go to 924
      return
c  error finish, insufficient array storage
  998 isn=0
      print 999
      stop
  999 format(44h0ARRAY BOUNDS EXCEEDED WITHIN SUBROUTINE FFT)
      end
c------------------------------------------------------------------------------
      function float_ask(request)
      character*(*) request
    2 write(6,100)request
  100 format(a,' ',$)
      read(5,*,err=1)float_ask
      return
    1 write(6,101)
  101 format(/,' **ERROR - try again')
      call bell
      go to 2
      end
c------------------------------------------------------------------------------
      subroutine getfile(unit,question,inout,form)
c      Opens files...filenames not recognized by VAX will generate
c      error message and request a second try.
c      Sample call:
c           call getfile(21,'*Give input file:','in','formatted')

      integer unit
      character filename*50, status*8
      character*(*) question, inout, form
c
      print *, ' '
 10   write(*,101) question
 101  format(a,' ',$)
      read '(a50)', filename
c
      if(inout.eq.'in') then
        status='old'
      else
        status='unknown'
      endif

      if(form.eq.'formatted'.and.inout.eq.'out') then
        open(unit,file=filename,form=form,status=status,
     &   err=900)
      else
        open(unit,file=filename,form=form,status=status,err=900)
      endif

      return
c
 900  print *,'ERROR IN OPENING ',filename
      print *,'   try again......'
      close(unit)
      go to 10
c
      end
c-----------------------------------------------------------------------------
      function int_ask(request)
      character*(*) request
    2 write(6,100)request
  100 format(a,' ',$)
      read(5,*,err=1)int_ask
      return
    1 write(6,101)
  101 format(/,' **ERROR - try again')
      call bell
      go to 2
      end
c------------------------------------------------------------------------------
      subroutine rdgrid(lun)
c      common/grdblk/grid(262144),ncol,nrow,col1,dcol,row1,drow,
       common/grdblk/grid(25600), ncol,nrow,col1,dcol,row1,drow,
     &              iproj,cmer,blat
c      dimension row(2000)
       dimension row(80)
      parameter (dvaltest=1.e38)
      index(i,j,ncol)=(j-1)*ncol+i
      call rdhead(lun)
      gmax=-.1e38
      gmin= .1e38
      ndval=0
      do 10 j=1,nrow
         call rowin(lun,row,ncol)
         do 10 i=1,ncol
            ij=index(i,j,ncol)
            if(row(i).gt.dvaltest)then
               ndval=ndval+1
               else
                  gmax=amax1(gmax,row(i))
                  gmin=amin1(gmin,row(i))
                  end if
   10       grid(ij)=row(i)
      write(6,100)gmin,gmax,ndval
  100 format(/,' GRID MINIMUM = ',g11.4,/,
     &         ' GRID MAXIMUM = ',g11.4,/,
     &         ' NO. DVALS    = ',i6,//)
      return
      end
c------------------------------------------------------------------------------
      subroutine wrgrid(lun)
c      common/grdblk/grid(262144),ncol,nrow,col1,dcol,row1,drow,
       common/grdblk/grid(25600), ncol,nrow,col1,dcol,row1,drow,
     &              iproj,cmer,blat
c      dimension row(2000)
       dimension row(80)
      character id*56,pgm*8
      index(i,j,ncol)=(j-1)*ncol+i
      write(6,100)
  100 format(' ID = ? '$)
      read(5,101)id
  101 format(a56)
      pgm='WRGRID  '
      nz=1
      write(lun)id,pgm,ncol,nrow,nz,col1,dcol,row1,drow,iproj,
     &          cmer,blat
      do 1 j=1,nrow
         do 2 i=1,ncol
            ij=index(i,j,ncol)
    2       row(i)=grid(ij)
    1 call rowout(lun,row,ncol)
      return
      end
c------------------------------------------------------------------------------
      function yn_ask(request)
      character*1 yn_ask
      character*(*) request
    2 write(6,100)request
  100 format(a,' ',$)
      read(5,102,err=1)yn_ask
  102 format(a1)
      if(yn_ask.eq.'Y')yn_ask='y'
      if(yn_ask.eq.'N')yn_ask='n'
      if(yn_ask.ne.'y'.and.yn_ask.ne.'n')go to 1
      return
    1 write(6,101)
  101 format(/,' **ERROR - try again')
      call bell
      go to 2
      end
c-----------------------------------------------------------------------------
      subroutine bell
      character*1 ding
      ding=char(007)
      print *, ding
      return
      end
c------------------------------------------------------------------------------
      subroutine rdhead(lun)
c      common/grdblk/grid(262144),ncol,nrow,col1,dcol,row1,drow,
       common/grdblk/grid(25600), ncol,nrow,col1,dcol,row1,drow,
     &              iproj,cmer,blat
      character id*56,pgm*8
      read(lun,err=1)id,pgm,ncol,nrow,nz,col1,dcol,row1,drow,iproj,
     &               cmer,blat
      go to 2
    1 rewind lun
      read(lun)id,pgm,ncol,nrow,nz,col1,dcol,row1,drow
      iproj=0
      cmer=0.
      blat=0.
    2 write(6,100)id,ncol,col1,dcol,nrow,row1,drow,iproj,cmer,blat
  100 format(/,' Header:  id = ',a56,//,
     &      5x,'ncol = ',i5,5x,'col1 = ',g11.4,5x,'dcol = ',g11.4,/,
     &      5x,'nrow = ',i5,5x,'row1 = ',g11.4,5x,'drow = ',g11.4,/,
     &      5x,'iproj= ',i5,5x,'cmer = ',g11.4,5x,'blat = ',g11.4,/)
      return
      end
c------------------------------------------------------------------------------
      subroutine rowin(lun,row,ncol)
      dimension row(ncol)
      read(lun)dummy,row
      return
      end
c------------------------------------------------------------------------------
      subroutine rowout(lun,row,ncol)
      dimension row(ncol)
      dummy=999.
      write(lun)dummy,row
      return
      end



