$STORAGE:2
      PROGRAM PFMAG3D
C***  NOTE: THIS PROGRAM HAS NOT YET BEEN TESTED ON THE IBM PC.
C -----------------------------------------------------------------------
C PROGRAM PFMAG3D CONDUCTS AN INTERACTIVE SESSION WITH THE USER THAT
C PREPARES INPUT TO AND REPORTS OUTPUT FROM SUBROUTINE FMAG3D.  THE
C QUESTIONS ASKED BY PFMAG3D SHOULD BE SELF-EXPLANATORY.  SEE THE COMMENTS
C IN SUBROUTINE FMAG3D AND THE DOCUMENTATION BY R.BLAKELY FOR MORE
C INFORMATION.
C THIS IS VERSION NUMBER 2.  THE MAIN DIFFERENCES BETWEEN THIS VERSION AND
C THE ORIGINAL VERSION ARE AS FOLLOWS:
C 1.  THE FIRST QUESTION OF VERSION 2 ASKS THE USER, 'DO YOU WANT VERBOSE
C PROMPTS?'  A YES ANSWER CAUSES CONVERSATION TO BE CHATTY; A NO ANSWER
C CAUSES TERSE CONVERSATION.
C 2.  GRIDS ARE CHECKED FOR THE PRESENCE OF DVALS AND TO BE SURE ALL GRIDS
C HAVE THE SAME DIMENSIONS.  VIOLATIONS ARE PUNISHABLE BY PROGRAM
C TERMINATION.
C 3.  VERSION 2 ASKS FOR BOTH NAUGX AND NAUGY (INSTEAD OF ONLY NAUG), WHICH
C ALLOWS MORE FLEXIBILITY IN EXPANDING GRIDS TO APPROPRIATE DIMENSIONS
C FOR THE FFT.  NOTE:  NAUGX AND NAUGY ARE THE DIMENSIONS TO WHICH THE
C GRIDS ARE EXPANDED; IN THE ORIGINAL VERSION, NAUG WAS THE NUMBER OF
C ROWS AND COLUMNS ADDED.
C 4.  THE ORIGINAL VERSION ASKS TWO QUESTIONS AFTER READING A TOPOGRAPHIC
C GRID IN ORDER TO MAKE TOPOGRAPHIC VALUES INCREASE DOWN AND TO CONVERT
C THEM TO THE SAME UNITS AS DX AND DY.  VERSION 2 ASKS FOR A SINGLE
C NUMBER TO ACCOMPLISH BOTH TASKS.  IF GRIDDED TOPOGRAPHIC VALUES INCREASE
C WITH ELEVATION, THEN THIS NUMBER SHOULD BE NEGATIVE.

C CONVERTED TO IBM PC BY W. D. GRUNDY  JULY 22, 1987
C TO FIT THIS PROGRAM INTO THE PC, IT WAS NECESSARY TO CHANGE ARRAYS
C OF 250x250 ELEMENTS INTO ARRAYS OF 80x80 ELEMENTS.
C THIS PC VERSION COMPILES UNDER MICROSOFT FORTRAN VERSION 4.00, BUT
C THE EXECUTABLE MODULE HAS YET TO BE TESTED AND CORRECTED FOR ANY
C BUGS THAT MIGHT BE ENCOUNTERED WHEN TESTED.
C REQUIRED STATPAC LIBRARY ROUTINES ARE AS FOLLOWS:
C ASCIIZ, CKSAFE, CLREOL, CONCAT, CRSOFF, CRSON, DELAY, ERRCHK,
C FNDCUR, INT21H, INTR, IOFS, ISEG, MOVCUR, PCHCEN, SAVRST, SCROLL,
C SOUND
C COMPILE AND LINK THIS PROGRAM AS FOLLOWS:
C FL /Od /4Nt pfmag3d.for /FPi87 /c
C LINK PFMAG3D /EXEPACK,,NUL,C:\LIB\STATPAC4+C:\LIB\LLIBFOR7
C -----------------------------------------------------------------------
      COMMON /INPUT/ S(6400),ZTOP(6400),ZBOT(6400),NX,NY,NAUGX,
     &NAUGY,SINCL,SDECL,FINCL,FDECL,AZIM,DX,DY,ZH,NSTOP,ERR2,
     &LULIST,LUTERM
      COMMON /OUTPUT/H(6400)
      DIMENSION XDUMMY(1),YDUMMY(1)
      CHARACTER*32 ZTOP_FILE,ZBOT_FILE,H_FILE,S_FILE,PRINT_FILE
      CHARACTER*56 ID
      CHARACTER*1 ANSWER
      LOGICAL*1 VERBOSE,FLAG
      PARAMETER(DVAL=#FFFF7FFF)
      DATA NXDIM/80/,NYDIM/80/
      INDEX(I,J,NY)=(I-1)*NY+J
      NGRID=0
C -----------------------------------------------------------------------
C --  PRINT A BANNER AND DETERMINE WHETHER VERBOSE PROMPTS ARE WANTED
C -----------------------------------------------------------------------
      WRITE(*,10)
   10 FORMAT(///,' WELCOME TO PFMAG3D - VERSION 2...'
     &' DO YOU WANT VERBOSE PROMPTS ? (Y OR N) '\)
      READ(*,'(A)') ANSWER
      VERBOSE=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      IF(VERBOSE)     WRITE(*,20)
   20 FORMAT(/,
     &' PFMAG3D IS A CONVERSATIONAL PROGRAM FOR CALCULATING A'
     &' RECTANGULAR',/,
     &' GRID OF MAGNETIC ANOMALY VALUES FROM THREE RECTANGULAR'
     &' GRIDS THAT',/,
     &' DEFINE THE SOURCE:  THE TOP SURFACE, THE BOTTOM SURFACE'
     &' AND THE',/,
     &' INTENSITY OF MAGNETIZATION.  MATHEMATICAL AND '
     &' PROGRAMMING CONCEPTS',/,
     &' ARE DESCRIBED IN USGS OPEN FILE 81-298.',//,
     &' PFMAG3D EXPECTS ALL GRIDS TO BE IN STANDARD FORMAT'
     &' WITH NO FLAGGED',/,
     &' VALUES (DVALS).  IT ALSO EXPECTS ALL GRIDS TO HAVE THE'
     &' SAME NUMBER',/,
     &' OF ROWS AND COLUMNS.  IF YOU HAVE PROBLEMS, CALL RICK'
     &' BLAKELY AT ',/,
     &' FTS 467-2624.'/)
C -----------------------------------------------------------------------
C --  OPEN THE FORMATTED FILE TO RECEIVE PROGRAM OUTPUT
C -----------------------------------------------------------------------
   30 WRITE(*,'(A\)') ' NAME OF PRINT-OUTPUT FILE = ? '
      READ(*,'(A)') PRINT_FILE
      CALL CKSAFE(PRINT_FILE,1,FLAG)
      IF(FLAG) GO TO 30
      OPEN(20,FILE=PRINT_FILE,FORM='FORMATTED',STATUS='UNKNOWN')
      WRITE(20,40)
   40 FORMAT(///,' PROGRAM PFMAG3D - VERSION 2....',//)
C -----------------------------------------------------------------------
C --  DETERMINE IF USER WANTS A FLAT, HORIZONTAL UPPER SURFACE.  IF SO,
C ENTER THE CONSTANT LEVEL
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,50)
      IF(.NOT.VERBOSE) WRITE(*,'(/,'' IS UPPER SURFACE FLAT ? '',\)')
   50 FORMAT(/,
     &' YOU WILL HAVE A CHOICE FOR BOTH THE UPPER AND'
     &' LOWER SURFACE OF THE',/,
     &' BODY:  IT CAN BE FLAT AND HORIZONTAL (IN WHICH'
     &' CASE YOU WILL BE',/,
     &' ASKED FOR THAT SINGLE LEVEL) OR IT CAN BE BUMPY'
     &' AND/OR TILTED (IN',/,
     &' WHICH CASE YOU WILL BE ASKED FOR THE NAME OF A'
     &' FILE CONTAINING THE',/,
     &' DIGITIZED SURFACE).',//,
     &' IS THE UPPER SURFACE OF THE BODY FLAT AND HORIZONTAL ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y') GO TO 150
C -----------------------------------------------------------------------
C --  OPEN AND READ THE STANDARD FILE CONTAINING THE GRIDDED UPPER SURFACE
C -----------------------------------------------------------------------
   60 WRITE(*,'(/,'' STANDARD FILE CONTAINING GRIDDED UPPER SURFACE'',
     &'' = ? '',\)')
      READ(*,'(A)') ZTOP_FILE
      CALL CKSAFE(ZTOP_FILE,2,FLAG)
      IF(FLAG) GO TO 60
      WRITE(20,70)ZTOP_FILE
   70 FORMAT(/,' FILE OF UPPER SURFACE = ',A32)
      OPEN(11,FILE=ZTOP_FILE,FORM='UNFORMATTED',STATUS='OLD')
      CALL READ_WRITE(0,11,ID,NY,NX,Y0,DY,X0,DX,ZTOP)
      WRITE(*,380)ID,NX,X0,DX,NY,Y0,DY
      WRITE(20,380)ID,NX,X0,DX,NY,Y0,DY
      NGRID=NGRID+1
      NXTEST=NX
      NYTEST=NY
      NTOTAL=NX*NY
C -----------------------------------------------------------------------
C -- CORRECT UPPER SURFACE TO METERS, POSITIVE DOWN (IF NECESSARY)
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,80)
      IF(.NOT.VERBOSE) WRITE(*,90)
   80 FORMAT(/,
     &' WHAT SINGLE NUMBER SHOULD THESE VALUES BE MULTIPLIED'
     &' BY SO THAT',/,
     &' THEY WILL INCREASE VERTICALLY DOWN AND HAVE THE SAME'
     &' UNITS AS DX',/,
     &' AND DY (FOR EXAMPLE, IF THE TOPOGRAPHIC VALUES ARE'
     &' IN METERS AND',/,
     &' AND INCREASE UPWARDS AND IF DX AND DY ARE IN'
     &' KILOMETERS, THEN',/,
     &' -.001 IS THE APPROPRIATE RESPONSE) = ? '\)
   90 FORMAT(/,' CONVERSION FACTOR = ? ',\)
      CALL ERRCHK(2,IDUM,TOPSCALE)
      TMAX=-.1E20
      TMIN= .1E20
      DO 100 I=1,NTOTAL
      IF(ZTOP(I).EQ.DVAL)CALL GERROR(250,*670)
      ZTOP(I)=ZTOP(I)*TOPSCALE
      TMAX=AMAX1(TMAX,ZTOP(I))
  100 TMIN=AMIN1(TMIN,ZTOP(I))
      WRITE(*,110)TMAX,TMIN
  110 FORMAT(/,' THE MAXIMUM AND MINIMUM OF THE UPPER SURFACE'
     &' ARE ',2G10.3/)
C -----------------------------------------------------------------------
C --  PRINTER CONTOUR THE UPPER SURFACE
C -----------------------------------------------------------------------
      WRITE(*,'(/,'' PRINTER CONTOUR THE UPPER SURFACE ? '',\)')
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'N'.OR.ANSWER.EQ.'n')GO TO 140
      IF(NX.LT.41.AND.NY.LT.41)GO TO 130
      WRITE(*,120)
  120 FORMAT(/,' GRID DIMENSIONS ARE TOO GREAT FOR CONTOURING')
      GO TO 140
  130 CONTINUE
      WRITE(*,'(/,'' CONTOUR INTERVAL = ? '',\)')
      CALL ERRCHK(2,IDUM,PC)
      CALL CONTP(PC,ZTOP,NX,NY,DX,DY,0.,0.,20,0.,0,0,XDUMMY,YDUMMY)
  140 CONTINUE
      GO TO 200
C -----------------------------------------------------------------------
C --  USER WANTS A FLAT UPPER SURFACE, SO READ THAT LEVEL
C -----------------------------------------------------------------------
  150 CONTINUE
      NTOTAL=NXDIM*NYDIM
      IF(VERBOSE)     WRITE(*,160)
      IF(.NOT.VERBOSE)WRITE(*,170)
  160 FORMAT(/,
     &' THE ELEVATION OF THE FLAT, HORIZONTAL UPPER'
     &' SURFACE (SAME UNITS AS',/,
     &' DX AND DY; REMEMBER, Z IS POSITIVE DOWN) = ? '\)
  170 FORMAT(/,' ELEVATION = ? '\)
      CALL ERRCHK(2,IDUM,ZCONST)
      DO 180 I=1,NTOTAL
  180 ZTOP(I)=ZCONST
      WRITE(20,190)ZCONST
  190 FORMAT(/,' TOP OF SOURCE IS FLAT AND HORIZONTAL'
     &' AT = ',G10.3/)
  200 CONTINUE
C -----------------------------------------------------------------------
C --  SEE IF USER WANTS A FLAT, HORIZONTAL BOTTOM; IF SO, READ THAT LEVEL
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,210)
      IF(.NOT.VERBOSE)WRITE(*,220)
  210 FORMAT(/,' IS THE BOTTOM SURFACE OF THE BODY FLAT'
     &' AND HORIZONTAL ? '\)
  220 FORMAT(/,' IS BOTTOM SURFACE FLAT ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y')GO TO 270
C -----------------------------------------------------------------------
C --  OPEN AND READ THE STANDARD FILE CONTAINING THE GRIDDED BOTTOM SURFACE
C -----------------------------------------------------------------------
  230 WRITE(*,'(/,'' STANDARD FILE CONTAINING GRIDDED BOTTOM'',
     &'' SURFACE = ? '',\)')
      READ(*,'(A)') ZBOT_FILE
      CALL CKSAFE(ZBOT_FILE,2,FLAG)
      IF(FLAG) GO TO 230
      WRITE(20,240)ZBOT_FILE
  240 FORMAT(/,' FILE OF BOTTOM SURFACE = ',A32)
      OPEN (12,FILE=ZBOT_FILE,FORM='UNFORMATTED',STATUS='OLD')
      CALL READ_WRITE(0,12,ID,NY,NX,Y0,DY,X0,DX,ZBOT)
      WRITE(*,380)ID,NX,X0,DX,NY,Y0,DY
      WRITE(20,380)ID,NX,X0,DX,NY,Y0,DY
C -----------------------------------------------------------------------
C --  TEST THIS GRID FOR GRID ERRORS
C -----------------------------------------------------------------------
      NGRID=NGRID+1
      IF(NGRID.GT.1)GO TO 250
      NXTEST=NX
      NYTEST=NY
  250 IF(NX.NE.NXTEST.OR.NY.NE.NYTEST)CALL GERROR(130,*670)
      NTOTAL=NX*NY
C -----------------------------------------------------------------------
C --  CORRECT BOTTOM SURFACE TO METERS, POSITIVE DOWN
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,80)
      IF(.NOT.VERBOSE)WRITE(*,90)
      CALL ERRCHK(2,IDUM,TOPSCALE)
      DO 260 I=1,NTOTAL
      IF(ZBOT(I).EQ.DVAL)CALL GERROR(250,*670)
  260 ZBOT(I)=ZBOT(I)*TOPSCALE
      GO TO 310
  270 CONTINUE
C -----------------------------------------------------------------------
C --  USER WANTS A FLAT BOTTOM SO CREATE ZBOT
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,280)
      IF(.NOT.VERBOSE)WRITE(*,170)
  280 FORMAT(/,
     &' THE ELEVATION OF THE FLAT, HORIZONTAL BOTTOM '
     &' SURFACE (SAME UNITS',/,
     &' AS DX AND DY; REMEMBER, Z IS POSITIVE DOWN) = ? '\)
      CALL ERRCHK(2,IDUM,ZCONST)
      DO 290 I=1,NTOTAL
      ZBOT(I)=ZCONST
  290 CONTINUE
      WRITE(20,300)ZCONST
  300 FORMAT(/,' BOTTOM OF SOURCE HAS A FLAT HORIZONTAL'
     &' BOTTOM = ',G10.3/)
  310 CONTINUE
C -----------------------------------------------------------------------
C --  SEE IF USER WANTS CONSTANT MAGNETIZATION; IF NOT, OPEN AND READ
C THE STANDARD FILE CONTAINING THE MAGNETIZATION
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,320)
      IF(.NOT.VERBOSE)WRITE(*,'(/,'' USE A CONSTANT MAGNETIZATION'',
     1'' ? '',\)')
  320 FORMAT(/,
     &' DO YOU WANT THE INTENSITY OF THE MAGNETIZATION'
     &' TO BE UNIFORM',/,
     &' EVERYWHERE BETWEEN THE TOP AND BOTTOM SURFACES ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'N'.OR.ANSWER.EQ.'n')GO TO 350
      WRITE(*,'(/,'' WHAT IS THE VALUE OF THE MAGNETIZATION'',
     1'' = ? '',\)')
      CALL ERRCHK(2,IDUM,C_MAG)
      WRITE(20,330)C_MAG
  330 FORMAT(/,' BODY HAS UNIFORM MAGNETIZATION = ',G10.3/)
      DO 340 I=1,NTOTAL
      S(I)=C_MAG
  340 CONTINUE
      GO TO 450
  350 CONTINUE
  360 WRITE(*,'(/,'' STANDARD FILE CONTAINING GRIDDED MAGNET'',
     &''IZATION = ? '',\)')
      READ(*,'(A)') S_FILE
      CALL CKSAFE(S_FILE,2,FLAG)
      IF(FLAG) GO TO 360
      WRITE(20,370)S_FILE
  370 FORMAT(/,' FILE OF MAGNETIZATION VALUES = ',A32)
      OPEN(10,FILE=S_FILE,FORM='UNFORMATTED',STATUS='OLD')
      CALL READ_WRITE(0,10,ID,NY,NX,Y0,DY,X0,DX,S)
      WRITE(*,380)ID,NX,X0,DX,NY,Y0,DY
      WRITE(20,380)ID,NX,X0,DX,NY,Y0,DY
  380 FORMAT(/,' HEADER:  ID = ',A56,/,10X,'NX = ',I5,5X,'X0 = '
     &,G10.3,5X,
     &'DX = ',G10.3,/,10X,'NY = ',I5,5X,'Y0 = ',G10.3,5X,
     &'DY = ',G10.3//)
C -----------------------------------------------------------------------
C --  TEST THIS GRID FOR GRID ERRORS
C -----------------------------------------------------------------------
      NGRID=NGRID+1
      IF(NGRID.GT.1)GO TO 390
      NXTEST=NX
      NYTEST=NY
  390 IF(NX.NE.NXTEST.OR.NY.NE.NYTEST)CALL GERROR(130,*670)
      DO 400 I=1,NTOTAL
  400 IF(S(I).EQ.DVAL)CALL GERROR(250,*670)
C -----------------------------------------------------------------------
C --  PRINTER CONTOUR THE MAGNETIZATION
C -----------------------------------------------------------------------
      WRITE(*,410)
  410 FORMAT(/,' PRINTER CONTOUR THE MAGNETIZATION ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'N'.OR.ANSWER.EQ.'n')GO TO 450
      IF(NX.LT.41.AND.NY.LT.41)GO TO 420
      WRITE(*,120)
      GO TO 450
  420 CONTINUE
      SMAX=-.1E20
      SMIN= .1E20
      DO 430 I=1,NTOTAL
      SMAX=AMAX1(SMAX,S(I))
      SMIN=AMIN1(SMIN,S(I))
  430 CONTINUE
      WRITE(*,440)SMAX,SMIN
  440 FORMAT(/,' THE MAXIMUM AND MINIMUM OF THE'
     &' MAGNETIZATION ARE ',2G10.3,//,
     &'  CONTOUR INTERVAL = ? '\)
      CALL ERRCHK(2,IDUM,PC)
      CALL CONTP(PC,S,NX,NY,DX,DY,0.,0.,20,0.,0,0,XDUMMY,YDUMMY)
  450 CONTINUE
C -----------------------------------------------------------------------
C --  OPEN THE STANDARD FILE TO RECEIVE THE GRIDDED ANOMALY
C -----------------------------------------------------------------------
  460 WRITE(*,'(/,'' STANDARD FILE TO RECEIVE GRIDDED ANOMALY'',
     &'' OUTPUT = ? '',\)')
      READ(*,'(A)') H_FILE
      CALL CKSAFE(H_FILE,1,FLAG)
      IF(FLAG) GO TO 460
      WRITE(20,470)H_FILE
  470 FORMAT(/,' FILE OF ANOMALY = ',A32)
      OPEN(13,FILE=H_FILE,FORM='UNFORMATTED',STATUS='UNKNOWN')
C -----------------------------------------------------------------------
C --  REQUEST A TITLE FOR THE OUTPUT
C -----------------------------------------------------------------------
      IF(VERBOSE)     WRITE(*,480)
      IF(.NOT.VERBOSE)WRITE(*,'(/,'' ID = ? '',\)')
  480 FORMAT(/,
     &' TYPE AN IDENTIFYING LABEL FOR THIS JOB, 56'
     &' CHARACTERS OR LESS.',/,
     &' THIS BECOMES PART OF THE HEADER RECORD OF THE'
     &' OUTPUT STANDARD GRID')
      READ(*,490)ID
  490 FORMAT(A56)
C -----------------------------------------------------------------------
C --  REQUEST THE VARIOUS INPUT PARAMETERS
C -----------------------------------------------------------------------
      IF(VERBOSE)     CALL FFTDIMS(NY,NX)
  500 CONTINUE
      IF(VERBOSE)     WRITE(*,510)
      IF(.NOT.VERBOSE)WRITE(*,520)
  510 FORMAT(/,
     &' ENTER THE FOLLOWING TEN PARAMETERS ONE AT A TIME'
     &'  ON SEPARATE LINES',/,
     &' SINCL = INCLINATION OF MAGNETIZATION IN DEGREES,'
     &' POSITIVE BELOW',/,
     &'         THE HORIZONTAL',/,
     &' SDECL = DECLINATION OF MAGNETIZATION IN DEGREES,'
     &' POSITIVE EAST OF',/,
     &'         OF TRUE NORTH',/,
     &' FINCL = INCLINATION OF REGIONAL FIELD (IN DEGREES)',/,
     &' FDECL = DECLINATION OF REGIONAL FIELD (IN DEGREES)',/,
     &' AZIM  = AZIMUTH OF POSITIVE X AXIS IN DEGREES, POSITIVE'
     &' EAST OF',/,
     &'         TRUE NORTH',/,
     &' ZH    = SURVEY ELEVATION IN SAME UNITS AS DX AND DY,'
     &' Z POSITIVE',/,
     &'         DOWN',/,
     &' NSTOP = LIMIT ON NUMBER OF SUMMATIONS, TYPICALLY 20',/,
     &' ERR2  = CONVERGENCE CRITERION FOR SUMMATIONS, TYPICALLY'
     &' 0.05',/,
     &' NAUGX = NUMBER OF ROWS IN EXPANDED GRIDS (MUST BE '
     &'GREATER THAN OR',/,
     &'         EQUAL TO NX; USE ABOVE LIST OF FFT DIMENSIONS'
     &' AS A GUIDE)',/,
     &' NAUGY = NUMBER OF COLUMNS IN EXPANDED GRIDS (MUST BE'
     &' GREATER THAN',/,
     &'         OR EQUAL TO NY)',/)
  520 FORMAT(/,
     &' ENTER:  SINCL,SDECL,FINCL,FDECL,AZIM,ZH,NSTOP,'
     &'ERR2,NAUGX,NAUGY',/)
      WRITE(*,'(/,'' ENTER VALUE OF SINCL = ? '',\)')
      CALL ERRCHK(2,IDUM,SINCL)
      WRITE(*,'('' ENTER VALUE OF SDECL = ? '',\)')
      CALL ERRCHK(2,IDUM,SDECL)
      WRITE(*,'('' ENTER VALUE OF FINCL = ? '',\)')
      CALL ERRCHK(2,IDUM,FINCL)
      WRITE(*,'('' ENTER VALUE OF FDECL = ? '',\)')
      CALL ERRCHK(2,IDUM,FDECL)
      WRITE(*,'('' ENTER VALUE OF AZIM  = ? '',\)')
      CALL ERRCHK(2,IDUM,AZIM)
      WRITE(*,'('' ENTER VALUE OF ZH    = ? '',\)')
      CALL ERRCHK(2,IDUM,ZH)
      WRITE(*,'('' ENTER VALUE OF NSTOP = ? '',\)')
      CALL ERRCHK(1,NSTOP,DUMMY)
      WRITE(*,'('' ENTER VALUE OF ERR2  = ? '',\)')
      CALL ERRCHK(2,IDUM,ERR2)
      WRITE(*,'('' ENTER VALUE OF NAUGX = ? '',\)')
      CALL ERRCHK(1,NAUGY,DUMMY)
      WRITE(*,'('' ENTER VALUE OF NAUGY = ? '',\)')
      CALL ERRCHK(1,NAUGX,DUMMY)
C -----------------------------------------------------------------------
C --  CHECK FOR VARIOUS ERRORS IN INPUT PARAMETERS
C -----------------------------------------------------------------------
      IF(NAUGX.LE.NXDIM.AND.NAUGY.LE.NYDIM.AND.NAUGX.GE.NX.AND.
     &NAUGY.GE.NY)  GO TO 540
      WRITE(*,530)
  530 FORMAT(/,' ERROR...NAUGX OR NAUGY EITHER EXCEED ARRAY ',/,
     &'DIMENSIONS OR THEY ARE LESS THAN NX OR NY...TRY AGAIN'/)
      GO TO 500
  540 CONTINUE
      WRITE(20,550)SINCL,SDECL,FINCL,FDECL,AZIM,ZH,NSTOP,ERR2,
     &NAUGX,NAUGY
  550 FORMAT(//,' THE INPUT PARAMETERS WERE...',//,
     &'  SINCL = INCLINATION OF MAGNETIZATION          = ',G10.3,/,
     &'  SDECL = DECLINATION OF MAGNETIZATION          = ',G10.3,/,
     &'  FINCL = INCLINATION OF REGIONAL FIELD         = ',G10.3,/,
     &'  FDECL = DECLINATION OF REGIONAL FIELD         = ',G10.3,/,
     &'  AZIM  = AZIMUTH OF POSITIVE X AXIS            = ',G10.3,/,
     &'  ZH    = ELEVATION OF SURVEY                   = ',G10.3,/,
     &'  NSTOP = LIMIT ON NUMBER OF SUMMATIONS         = ',I5,/,
     &'  ERR2  = CONVERGENCE CRITERION FOR SUMMATIONS  = ',G10.3,/,
     &'  NAUGX = ROWS ADDED TO ARRAYS                  = ',I5,/,
     &'  NAUGY = COLUMNS ADDED TO ARRAYS               = ',I5//)
      LUTERM=6
      LULIST=20
      NAUGX=NAUGX-NX
      NAUGY=NAUGY-NY
C -----------------------------------------------------------------------
C --  CALL THE SUBROUTINE FMAG3D
C -----------------------------------------------------------------------
      CALL FMAG3D
C -----------------------------------------------------------------------
C --  PRINT THE GRIDDED ANOMALY
C -----------------------------------------------------------------------
      WRITE(*,560)NX*(NY/10+1)
  560 FORMAT(/,' INCLUDE ANOMALY VALUES IN PRINT OUTPUT (LIST ',/,
     &'WILL BE ',  I7,' LINES LONG) ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'N'.OR.ANSWER.EQ.'n')GO TO 610
      WRITE(20,570)
  570 FORMAT(//,2X,'X DECREASES',2X,'|',10X,'CALCULATED ANOMALY '
     &' Y INCREASES',
     &' TO THE RIGHT)',/,6X,'DOWN',5X,'|',/,1X,14('-'),'|',
     &110('-'),/,
     &15X,'|')
      I=NX
      DO 600 L=1,NX
      I1=INDEX(I,1,NY)
      I2=I1+9
      X=X0+(I-1)*DX
      WRITE(20,580)X,(H(M),M=I1,I2)
  580 FORMAT(5X,G10.3,'|',10G11.4)
      IF(NY.GT.10)GO TO 600
      I3=I2+1
      I4=INDEX(I,NY,NY)
      WRITE(20,590)(H(M),M=I3,I4)
  590 FORMAT(15X,'|',10G11.4)
  600 I=I-1
  610 CONTINUE
C -----------------------------------------------------------------------
C --  SEND THE ANOMALY OUTPUT TO THE STANDARD FILE
C -----------------------------------------------------------------------
      CALL READ_WRITE(1,13,ID,NY,NX,Y0,DY,X0,DX,H)
C -----------------------------------------------------------------------
C --  CALCULATE AND REPORT CERTAIN STATISTICS ABOUT THE ANOMALY
C -----------------------------------------------------------------------
      SUMH=0.
      HMAX=-.1E20
      HMIN= .1E20
      DO 620 I=1,NTOTAL
      SUMH=SUMH+H(I)
      HMAX=AMAX1(HMAX,H(I))
      HMIN=AMIN1(HMIN,H(I))
  620 CONTINUE
      SUMH=SUMH/NTOTAL
      WRITE(*,630)HMAX,HMIN,SUMH
  630 FORMAT(/,' THE MAX, MIN, AND AVERAGE VALUES OF THE ANOMALY'
     &' ARE ',G11.4,
     &/,53X,G11.4,/,53X,G11.4/)
C -----------------------------------------------------------------------
C --  CONTOUR THE ANOMALY IF DESIRED
C -----------------------------------------------------------------------
      WRITE(*,640)
  640 FORMAT(/,' PRINTER CONTOUR THE ANOMALY ? '\)
      READ(*,'(A)') ANSWER
      IF(ANSWER.EQ.'N'.OR.ANSWER.EQ.'n')GO TO 660
      IF(NX.LT.41.AND.NY.LT.41)GO TO 650
      WRITE(*,120)
      GO TO 660
  650 CONTINUE
      WRITE(*,'(/,'' CONTOUR INTERVAL = ? '',\)')
      CALL ERRCHK(2,IDUM,PC)
      CALL CONTP(PC,H,NX,NY,DX,DY,0.,0.,20,0.,0,0,XDUMMY,YDUMMY)
  660 CONTINUE
C -----------------------------------------------------------------------
C --  TERMINATION OF PROGRAM
C -----------------------------------------------------------------------
  670 CONTINUE
      CLOSE(10)
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(20)
      CLOSE(6)
      CLOSE(5)
      STOP
      END
      SUBROUTINE GERROR(IFLAG,*)
      GO TO (10,30) IFLAG
   10 WRITE(*,20)
   20 FORMAT(/,' ERROR...A DVAL WAS ENCOUNTERED IN THE GRID.')
      RETURN 1
   30 WRITE(*,40)
   40 FORMAT(/,' ERROR...GRID DIMENSIONS DO NOT MATCH PREVIOUS'
     &' GRID(S).')
      RETURN 1
      END
      SUBROUTINE FFTDIMS(NCOL,NROW)
C -----------------------------------------------------------------------
C PRINTS OUT NUMBERS LESS THAN 1024 WITH NO PRIME FACTOR GREATER THAN 5.
C THE FFT ALGORITHM WORKS FASTEST FOR THESE NUMBERS.
C SUBROUTINE PRINTS OUT GOOD NUMBERS BETWEEN
C MIN OF (NCOL,NROW) AND MAX OF (NCOL+100,NROW+100).
C -----------------------------------------------------------------------
      DIMENSION NLIST(104),NGOOD(100)
C -----------------------------------------------------------------------
C FIRST 2 COLS FROM TABLE III OF SINGLETON'S PAPER ON FFT....
C (SINGLETON,R.C., 1969, AN ALGOTITHM FOR COMPUTING THE MIXED
C RADIX FAST FOURIER TRANSFORM:  IEEE TRANS., AUDIO AND ELECTRO-
C ACOUSTICS: V. AU-17, P. 93-103.
C -----------------------------------------------------------------------
      DATA NLIST/2,3,4,5,6,8,9,10,12,15,16,18,20,24,25,27,30,
     &32,36,40,45,48,50,54,60,64,72,75,80,81,90,96,100,108,120,
     &125,128,135,144,150,160,162,180,192,200,216,225,240,
     &243,250,256,270,288,300,320,324,360,375,384,400,405,432,450,
     &480,486,500,512,540,576,600,625,640,648,675,720,729,750,
     &768,800,810,864,900,960,972,1000,1024,1080,1125,1152,1200,
     &1215,1250,1280,1296,1350,1440,1458,1500,1536,1600,1620,1728,
     &1800,1875/
C
      MIN=MIN0(NCOL,NROW)
      IF(MIN.EQ.1) MIN=MAX0(NCOL,NROW)
      MAX=MAX0(NCOL+100,NROW+100)
      N=0
      DO 10 I=1,104
      IF(NLIST(I).LT.MIN) GO TO 10
      IF(NLIST(I).GT.MAX) GO TO 20
      N=N+1
      NGOOD(N)=NLIST(I)
   10 CONTINUE
C
   20 WRITE(*,30)
   30 FORMAT(' SUGGESTED VALUES FOR NAUGX AND NAUGY:')
      WRITE(*,40) (NGOOD(I),I=1,N)
   40 FORMAT('      ',14I5)
C
      RETURN
      END
      SUBROUTINE READ_WRITE(MODE,LUN,ID,NCOL,NROW,COL1,DELCOL,
     &ROW1,DELROW,ARRAY)
      DIMENSION ARRAY(1),WORK(1000)
      CHARACTER*56 ID
      CHARACTER*8 PGM
C -----------------------------------------------------------------------
C THIS SUBROUTINE READS A STANDARD FILE INTO A ONE-DIMENSIONAL ARRAY.
C INPUTS ARE MODE (0 FOR READ, 1 FOR WRITE) AND LUN (LOGICAL UNIT NUMBER).
C OUTPUTS ARE ID,NCOL,NROW,COL1,DELCOL,ROW1,DELROW, AND ARRAY.
C -----------------------------------------------------------------------
      IF(MODE.EQ.1)GO TO 10
      READ(LUN)ID,PGM,NCOL,NROW,NZ,COL1,DELCOL,ROW1,DELROW
      GO TO 20
   10 NZ=1
      PGM='PFMAG3D '
      WRITE(LUN)ID,PGM,NCOL,NROW,NZ,COL1,DELCOL,ROW1,DELROW
   20 CONTINUE
C
      DO 60 J=1,NROW
      L=0
      I1=(J-1)*NCOL+1
      I2=I1+NCOL-1
      IF(MODE.EQ.1)GO TO 40
      CALL ROW_READ(LUN,WORK,NCOL)
      DO 30 I=I1,I2
      L=L+1
   30 ARRAY(I)=WORK(L)
      GO TO 60
   40 CONTINUE
      DO 50 I=I1,I2
      L=L+1
   50 WORK(L)=ARRAY(I)
      CALL ROW_WRITE(LUN,WORK,NCOL)
   60 CONTINUE
      RETURN
      END
      SUBROUTINE ROW_READ(LUN,WORK,NCOL)
      DIMENSION WORK(NCOL)
      READ(LUN)DUMMY,WORK
      RETURN
      END
      SUBROUTINE ROW_WRITE(LUN,WORK,NCOL)
      DIMENSION WORK(NCOL)
      DUMMY=999.
      WRITE(LUN)DUMMY,WORK
      RETURN
      END
      SUBROUTINE CONTP(PC,A,M,N,DX,DY,XMN,YMN,IOUT,SCL,
     &LAXCOL,LB,XB,YB)
C -----------------------------------------------------------------------
C DONALD PLOUFF PRINTER CONTOUR ROUTINE
C PC,DC---THE INCREMENT IN THE CONTOUR VALUES (READ IN)
C A(Y,X)---THE INPUT ARRAY CONTAINING THE DATA TO BE CONTOURED.
C INDEX FOR EQUIVALENT 1D ARRAY IS N*(X-1)+Y
C THE ONE-DIMENSINAL A-ARRAY IS FILLED (WITHOUT VOIDS) IN ROWS, STARTING
C FROM MINIMUM X (XMN) TOWARD MAXIMUM X. WITHIN EACH ROW THE PROGRES-
C SION IS FROM MINIMUM Y (YMN) TO MAXIMUM Y.
C M---THE  FINAL  VALUE OF X-INDEX IN A-ARRAY, STARTING AT 1
C N---THE  FINAL  VALUE OF Y-INDEX IN A-ARRAY, STARTING AT 1
C X INCREASES TO RIGHT AND Y INCREASES DOWNWARD
C DX,DY ARE RESPECTIVE GRID INTERVALS IN DISTANCE UNITS
C IOUT IS UNIT NUMBER OF PRINTER
C SCL IS SCALE IN DISTANCE UNITS PER INCH. DEFAULT FILLS PAGE.
C LB IS NUMBER OF (XB,YB) LOCATIONS TO BE SUPERIMPOSED ON PLOT. IF THIS
C FACILITY IS NOT NEEDED, THEN LB=0 (ALSO XMN,YMN NOT NEEDED).
C NOTE THAT THIS SUBROUTINE CHANGES THE VALUES OF XB AND YB.
C NX IS NUMBER OF INTERVALS IN X-DIRECTION (RIGHT) LESS THAN 41.
C NY IS NUMBER OF INTERVALS IN Y-DIRECTION (DOWN)  LESS THAN 41.
C -----------------------------------------------------------------------
      INTEGER PNT(131),SYM(35),            C,      IY(41),JX(41)
      DIMENSION A(1),XB(1),YB(1)
C -----------------------------------------------------------------------
C DIMENSION A(41,41),XB(1),YB(1)
C -----------------------------------------------------------------------
      DATA SYM/'1','2','3','4','5','6','7','8','9','A','B',
     &'C','D','E',
     &'F','G','H','I','J','K','L','M','N','O','P','Q','R',
     &'S','T',
     &'U','V','W','X','Y','Z'/,IHOR/'-'/,IVERT/'|'/,
     &JPLUS/'+'/
      DATA        IBLANK,JEX /   ' ','*'/
      NAXCOL=LAXCOL-1
C -----------------------------------------------------------------------
C NEEDS CARRIAGE WITH 132 COLUMNS AVAILABLE OR CHANGE NAXCOL
C -----------------------------------------------------------------------
      IF (NAXCOL .EQ. -1) NAXCOL=131
      IF (M .LT. 2) GO TO 480
      IF (M .GT. 41) GO TO 480
      IF (N .LT. 2) GO TO 480
      IF (N .GT. 41) GO TO 480
      DC=PC
      NB=LB
      NX=M-1
      NY=N-1
      NT=N*M
      XMX=XMN+DX*NX
      YMX=YMN+DY*NY
      IF (SCL .LE. 0.0) GO TO 10
      MAXCOL=10.0*DX*NX/SCL+1.5
      IF (MAXCOL .GT. NAXCOL) GO TO 10
      GO TO 30
   10 MAXCOL=NAXCOL
      WRITE (IOUT,20)
   20 FORMAT (5X,'PRINTER SCALE IS EXPANDED TO FILL PAGE.')
   30 WRITE (IOUT,40) M,N,NT,XMN,XMX,YMN,YMX,DC
   40 FORMAT (5X,'EXPECT PRINTER PLOT OF',I3,' BY',I3,
     &'(',I3,') ARRAY.',
     &' X=',F8.1,' TO',F8.1,' Y=',F8.1,' TO',F8.1,
     &' CONTOURED AT',
     &F7.1,' UNITS')
      FMIN= 1.0E20
      FMAX=-1.0E20
      DO 50 I=1,NT
      AIJ=A(I)
      IF (AIJ .GT. FMAX) FMAX=AIJ
      IF (AIJ .LT. FMIN) FMIN=AIJ
   50 CONTINUE
   60 IC=1.0+FMIN/DC
      IF (IC .LT. 0) IC=IC-1
      JC=FMAX/DC
      IF (JC .LT. 0) JC=JC-1
      NCONT=JC-IC+1
      IF (NCONT .LT. 36) GO TO 80
      WRITE  (IOUT,70) DC
   70 FORMAT (5X,'REQUESTED CONTOUR INTERVAL OF',F9.4, ' IS DOUBLED',
     &' BECAUSE MORE THAN 35 CONTOURS ARE PRODUCED.')
      DC=2.0*DC
      GO TO 60
   80 CD=1.0/DC
      CI=DC*IC
C -----------------------------------------------------------------------
C CF=DC*JC
C -----------------------------------------------------------------------
      WIDTH=MAXCOL-1
      UX=NX/WIDTH
C -----------------------------------------------------------------------
C NUMBER OF COLUMNS IN ONE GRID INTERVAL
C -----------------------------------------------------------------------
      FJINC=1.0/UX
      FJINCP=0.5+FJINC
      COLEFM=1.0-FJINC
C -----------------------------------------------------------------------
C MAINTAINS TRUE PROPORTIONS WITH X EXPANDED TO MAXCOL-1 COLUMNS
C -----------------------------------------------------------------------
      UY=  DX*UX/(  DY*0.6)
      IF (UY .LT. 1.0) GO TO 100
      UY=1.0/UY
      WRITE  (IOUT,90) UY
   90 FORMAT(5X,'Y-DISTANCES ARE EXAGGERATED BY',F9.4,
     &' FOR CONTOURING')
      UY=1.0
C -----------------------------------------------------------------------
C NUMBER OF COLUMNS PER UNIT DISTANCE
C -----------------------------------------------------------------------
  100 DLX=FJINC/DX
      FIINC=1.0/UY
      DLY=FIINC/DY
      ROW=1.0
      DO  110 K=1,NY
      ROW=ROW+FIINC
  110 IY(K)=ROW+0.5
      LASTRW=IY(NY)
      COL=1.0
      DO  120 K=1,M
      JX(K)=COL+0.5
  120 COL=COL+FJINC
      IF (NB .EQ. 0) GO TO 180
      L=0
      NF=1
  130 DO  140 K=NF,NB
      KK=K
      DUM=XB(K)
      IF (DUM .LT. XMN) GO TO 150
      IF (DUM .GT. XMX) GO TO 150
      KX=1.5001+DLX*(DUM-XMN)
      DUM=YB(K)
      IF (DUM .LT. YMN) GO TO 150
      IF (DUM .GT. YMX) GO TO 150
      KY=1.5001+DLY*(DUM-YMN)
      L=L+1
C -----------------------------------------------------------------------
C CHARGES XB/YB. PROVIDE ANOTHER ARRAY, IF VALUES NEEDED.
C -----------------------------------------------------------------------
      XB(L)=KX
  140 YB(L)=KY
      GO TO 170
  150 NF=KK+1
      WRITE  (IOUT,160) XB(KK),YB(KK)
  160 FORMAT (5X,'BODY POINT X=',F10.3,' Y=',F10.3,' IS OUTSIDE',
     &' CONTOUR PLOT.')
      IF (KK .LT. NB) GO TO 130
  170 NB=L
  180 CM=CI-DC
      DO 190 I=1,NT
C -----------------------------------------------------------------------
C CHANGES VALUES INPUTTED AS 'A' (RESTORED LATER).
C -----------------------------------------------------------------------
  190 A(I)=CD*(A(I)-CM)
      JR=1
C -----------------------------------------------------------------------
C LOOP OF ROWS FROM TOP TO BOTTOM
C -----------------------------------------------------------------------
      DO 410 JROW=1,LASTRW
      ROW=1.0+UY*(JROW-1)
C -----------------------------------------------------------------------
C MAJOR GRID INDEX (I) INCREASES ONCE EACH FIINC ROWS
C -----------------------------------------------------------------------
      I=ROW
      FUL=ROW-I
      IND=0
      KT=I-N
      DO 200 L = 1,MAXCOL
  200 PNT(L) = IBLANK
      COLEFT=COLEFM
C -----------------------------------------------------------------------
C LOOP OF GRID INTERVALS FROM LEFT TO RIGHT
C -----------------------------------------------------------------------
      DO 280 J=1,NX
      COLEFT=COLEFT+FJINC
      IF (JROW .EQ. LASTRW) GO TO 210
      KT=KT+N
      KB=KT+N
      DUM = A(KT)
      ZL = DUM + FUL*(A(KT+1) -DUM)
      DUM = A(KB)
      ZR = DUM + FUL*(A(KB+1) -DUM)
      GO TO 220
  210 IND=IND+N
      ZL=A(IND)
      KB=IND+N
      ZR=A(KB)
  220 DEN = ZR-ZL
      IF (ABS(DEN) .GT. 0.000001) GO TO 240
      IZC=ZL
      FL=IZC
      IF (FL .NE. ZL) GO TO 280
      LEFT=COLEFT+0.5
      JRT=COLEFT+FJINCP
C -----------------------------------------------------------------------
C LOOP OF CONTOURS IN THIS GRID INTERVAL
C -----------------------------------------------------------------------
      DO 230 L=LEFT,JRT
  230 PNT(L)=SYM(IZC)
      GO TO 280
  240 IF (ZL .GT. ZR) GO TO 250
      FMIN=ZL
      FMAX=ZR
      GO TO 260
  250 FMIN=ZR
      FMAX=ZL
  260 LMIN=FMIN+0.9999
      LMAX=FMAX
      IF (LMAX .EQ. 0) GO TO 280
      IF (LMAX .LT. LMIN) GO TO 280
      RATIO=FJINC/DEN
      DO 270 IZC=LMIN,LMAX
      C=COLEFT+RATIO*(IZC-ZL)
  270 PNT(C)=SYM(IZC)
  280 CONTINUE
      IF (NB .EQ. 0) GO TO 330
      ROW=JROW
      NF=1
  290 DO 300 K=NF,NB
      KK=K
      IF (YB(K) .EQ. ROW) GO TO 310
  300 CONTINUE
      GO TO 330
  310 NB=NB-1
      KX=XB(KK)+0.5
      PNT(KX)=JEX
      IF (KK .GT. NB) GO TO 330
      NF=KK
      DO 320 K=NF,NB
      KP=K+1
      XB(K)=XB(KP)
  320 YB(K)=YB(KP)
      GO TO 290
  330 ITEST=0
      IF (JROW .EQ. LASTRW) GO TO 370
      IF (JROW .EQ.      1) GO TO 370
      IF (JROW .EQ. IY(JR)) GO TO 360
      IF (PNT(MAXCOL) .EQ. IBLANK) PNT(MAXCOL)=IVERT
      IF (PNT(     1) .EQ. IBLANK) PNT(     1)=IVERT
  340 WRITE  (IOUT,350) (PNT(K),K=1,MAXCOL)
  350 FORMAT ( 1X,131A1)
      GO TO 410
  360 ITEST=1
      JR=1+JR
  370 DO 380 K=1,M
      KX=JX(K)
      IF (PNT(KX) .EQ. IBLANK) PNT(KX)=JPLUS
  380 CONTINUE
      IF (ITEST .EQ. 1) GO TO 340
      DO 390 K=1,MAXCOL
      IF (PNT(     K) .EQ. IBLANK) PNT(     K)=IHOR
  390 CONTINUE
      IF (JROW .EQ. LASTRW) GO TO 420
      WRITE  (IOUT,400) (PNT(K),K=1,MAXCOL)
  400 FORMAT ('1',131A1)
  410 CONTINUE
  420 WRITE  (IOUT,350) (PNT(K),K=1,MAXCOL)
      WRITE  (IOUT,430)
  430 FORMAT(//,' LEGEND',/,' SYMBOL',8X,'VALUE',12X,
     &'X INCREASES'
     &' TO RIGHT AND Y INCREASES DOWNWARD')
      ZC = CI-DC
      DO 440 I=1,NCONT
      ZC=ZC+DC
  440 WRITE  (IOUT,450) SYM(I),ZC
  450 FORMAT(' ',3X,A1,6X,F14.4)
      WRITE  (IOUT,460)
  460 FORMAT(4X,'+',6X,'GRID POINT', 14X,'*',6X,'LOCATION MARK')
      DO 470 I=1,NT
  470 A(I)=CM+DC*A(I)
      RETURN
  480 WRITE (IOUT,490) M,N
  490 FORMAT('0','GRID OF',I4,' BY',I4,' (X,Y) IS TOO LARGE'
     &' (41) OR ',
     &'TOO SMALL FOR PRINTER CONTOUR.')
      RETURN
      END
      SUBROUTINE FMAG3D
C -----------------------------------------------------------------------
C SUBROUTINE FMAG3D COMPUTES A RECTANGULAR GRID OF ANOMALY VALUES, H(X,Y),
C FROM THREE RECTANGULAR GRIDS WHICH DEFINE THE DISTRIBUTION OF MAGNETIC
C MATERIAL:  THE TOP SURFACE, ZTOP(X,Y); THE BOTTOM SURFACE, ZBOT(X,Y); AND
C THE MAGNETIC INTENSITY, S(X,Y).  THE CORNERS AND SAMPLE INTERVALS OF EACH
C OF THESE FOUR GRIDS ARE ASSUMED TO BE THE SAME.
C ALGORITHM
C THE METHOD IS DESCRIBED BY R. L. PARKER (GEOPHYSICAL JOURNAL, V. 31,
C P. 447, 1973).  IT SOLVES THE SUMMATION
C M
C H = IF[B * SUM( A * F[S * (ZBOT**N - ZTOP**N)])]
C N=0
C WHERE F AND IF DENOTE TWO-DIMENSIONAL FOURIER TRANSFORMS AND INVERSE
C TRANSFORMS, RESPECTIVELY.  THE SUMMATION IS CONTINUED UNTIL SUFFICIENT
C CONVERGENCE OCCURS.  THE RATE OF CONVERGENCE DEPENDS ON THE ELEVATION OF
C THE ORIGIN WITH RESPECT TO THE MAGNETIC BODY AND THE LEVEL OF OPTIMUM
C CONVERGENCE CHANGES AT DIFFERENT PARTS OF THE ALGORITHM.  THUS UPWARD
C AND DOWNWARD CONTINUATION OCCURS MANY TIMES IN THE COURSE OF A RUN.
C INPUT
C ALTHOUGH THE ARRAYS H, ZTOP, ZBOT, AND S ARE SINGLY DIMENSIONED, THEY
C NEVERTHELESS REPRESENT TWO-DIMENSIONAL ARRAYS.  THESE INCREASE FIRST ALONG
C THE Y AXIS AND THEN ALONG THE X AXIS.  FOR EXAMPLE,
C X AXIS
C ^
C |
C |
C S((NX-1)*NY+1)..........................S(NX*NY)
C.                                       .
C.                                       .
C.                                       .
C.                                       .
C S(NY+1)       S(NY+2)       S(NY+3) ... S(NY+NX)
C S(1)          S(2)          S(3)    ... S(NY)     --->  Y AXIS
C ALL OF THE INPUT ARRAYS AND PARAMETERS ARE SUPPLIED TO FMAG3D THROUGH
C LABELED COMMON.  AN ITEMIZED LIST FOLLOWS:
C S      - THE ARRAY OF MAGNETIC INTENSITY VALUES
C ZTOP   - THE ARRAY REPRESENTING THE MAGNETIC INTENSITY
C ZBOT   - THE ARRAY REPRESENTING THE BOTTOM SURFACE
C NX     - THE NUMBER OF ARRAY ELEMENTS IN THE X DIRECTION
C NY     - THE NUMBER OF ARRAY ELEMENTS IN THE Y DIRECTION
C NAUGX  - THE NUMBER OF ROWS TO ADD TO THE INPUT ARRAYS
C NAUGY  - THE NUMBER OF COLUMNS TO ADD TO THE INPUT ARRAYS
C SINCL  - THE INCLINATION OF THE MAGNETIZATION
C SDECL  - THE DECLINATION OF THE MAGNETIZATION
C FINCL  - THE INCLINATION OF THE REGIONAL FIELD
C FDECL  - THE DECLINATION OF THE REGIONAL FIELD
C AZIM   - THE AZIMUTH OF THE X AXIS WITH RESPECT TO NORTH (POSITIVE EAST)
C DX     - THE SAMPLE INTERVAL OF THE ARRAYS IN THE X DIRECTION
C DY     - THE SAMPLE INTERVAL OF THE ARRAYS IN THE Y DIRECTION
C ZH     - THE ELEVATION OF THE SURVEY
C NSTOP  - THE LIMIT OF SUMMATIONS, IF CONVERGENCE DOES NOT OCCUR
C ERR2   - THE DEFINITION OF CONVERGENCE (SEE NOTE BELOW)
C LULIST - THE LOGICAL UNIT NUMBER TO RECEIVE PRINTED OUTPUT
C LUTERM - THE LOGICAL UNIT NUMBER TO RECEIVE TERMINAL OUTPUT
C UNITS
C THE UNITS OF DISTANCE FOR ZBOT, ZTOP, DX, DY, AND ZH DO NOT MATTER SO
C LONG AS THEY ARE CONSISTENT.  THE UNITS OF ANGLES FOR SINCL, SDECL, FINCL,
C FDECL, AND AZIM ARE DEGREES.  INCLINATIONS AND DECLINATIONS ARE DEFINED
C IN THE USUAL WAY.  THE UNIT OF MAGNETIZATION FOR S IS EMU/CC.
C OUTPUT
C THE ONLY OUTPUT IS THE ARRAY H, THE MAGNETIC ANOMALY; UNITS ARE GAMMAS
C NOTES
C 1 - CONVERGENCE IS ASSUMED TO OCCUR WHEN THE ABSOLUTE VALUE OF THE
C NTH TERM IS ERR2 TIMES THE ABSOLUTE VALUE OF THE SUM OF ALL PREVIOUS
C TERMS.  A TYPICAL VALUE FOR ERR2 IS .001
C 2 - SUBROUTINE FMAG3D CALLS A FAST-FOURIER TRANSFORM SUBROUTINE CALLED
C FFT WRITTEN BY R.C. SINGLETON (IEEE TRANS. AUDIO ELECTROAC., V.
C AU-17, P. 93, 1969).  SUBROUTINE FFT IS FASTER IF THE SIZE OF THE
C ARRAY BEING TRANSFORMED CAN BE FACTORED INTO MANY SMALL PRIME
C NUMBERS, AND IN FACT CERTAIN DIMENSIONS ARE NOT PERMITTED BY FFT
C (SEE THE DOCUMENTATION IN FFT FOR DETAILS).  BECAUSE THE ARRAYS
C BEING SENT TO FMAG3D ARE NOT NECESSARILY GOING TO HAVE OPTIMAL
C DIMENSIONS, A FACILITY IS AVAILABLE TO AUGMENT ROWS AND COLUMNS.
C THE NUMBER OF ROWS AND COLUMNS ADDED ARE NAUGX AND NAUGY,
C RESPECTIVELY;  THE ELEMENTS ARE CALCULATED SO AS TO MAKE THE
C ARRAYS MORE PERIODIC THUS REDUCING EDGE EFFECT PROBLEMS.
C THESE ADDITIONAL ROWS AND COLUMNS ARE
C DISCARDED BY FMAG3D BEFORE SENDING RESULTS BACK TO THE CALLING
C PROGRAM.
C 3 - A NON-STANDARD SUBROUTINE, SET_UNDER, IS CALLED TWICE.
C THIS SUBROUTINE ACTIVATES AND DEACTIVATES THE STANDARD FAULT HANDLING
C MECHANISMS FOR UNDERFLOWED CALCULATIONS.  AT ONE LOCATION OF FMAG3D,
C NUMEROUS UNDERFLOWS MAY OCCUR AND CONSIDERABLE CPU EXPENSE IS SAVED
C BY EXCEPTING THE STANDARD FIXUP (ZERO) VIA SET_UNDER.
C FOR USE ON COMPUTERS OTHER THAN MULTICS, SET_UNDER SHOULD BE
C ELIMINATED OR REPLACED BY A SIMILAR ROUTINE.
C 4 - FOR FURTHER INFORMATION, SEE THE PAPER, 'A PROGRAM FOR RAPIDLY
C COMPUTINE THE MAGNETIC ANOMALY OVER DIGITAL TOPOGRAPHY', USGS
C OPEN FILE REPORT, 1981, BY R. J. BLAKELY.
C -----------------------------------------------------------------------
      COMMON /INPUT/ S(6400),ZTOP(6400),ZBOT(6400),NX,NY,NAUGX,
     &NAUGY,SINCL,SDECL,FINCL,FDECL,AZIM,DX,DY,ZH,NSTOP,ERR2,
     &LULIST,LUTERM
      COMMON /OUTPUT/H(6400)
      COMMON /INTER1/WORK1(80,80),WORK2(80,80)
      COMMON /INTER3/FCMPLX(6400)
      COMMON /INTER2/SUM(6400),K(6400),KX(80),KY(80),FACT(31)
      COMMON /INTER4/HCMPLX(6400),EXPBOT(6400),EXPTOP(6400)
      COMPLEX SUM,PHI,CMPLX,HCMPLX,FCMPLX
      REAL MX,MY,MZ,KX,KY,K,K2,KX2,KY2
      CHARACTER*3 MODE
      DATA TWOPI/6.2831853/,CONV/.01745329/,EPSLON/.1E-10/
      INDEX(I,J,NY)=(I-1)*NY+J
C -----------------------------------------------------------------------
C --  AUGMENT THE ARRAYS TO REDUCE EDGE EFFECTS AND SPEED UP FFT
C -----------------------------------------------------------------------
      IF(NAUGX.EQ.0.AND.NAUGY.EQ.0)GO TO 10
      CALL AUGMENT(S,NY,NX,NAUGY,NAUGX,1)
      CALL AUGMENT(ZTOP,NY,NX,NAUGY,NAUGX,1)
      CALL AUGMENT(ZBOT,NY,NX,NAUGY,NAUGX,1)
      NX=NX+NAUGX
      NY=NY+NAUGY
   10 CONTINUE
C -----------------------------------------------------------------------
C --  INITIALIZE A FEW PARAMETERS
C -----------------------------------------------------------------------
      DO 20 I=1,NSTOP
      FACT(I)=1./FAC(I,IER)
   20 CONTINUE
      DKX=TWOPI/(NX*DX)
      DKY=TWOPI/(NY*DY)
      NTOTAL=NX*NY
      NNX=NX/2+1
      NNY=NY/2+1
C -----------------------------------------------------------------------
C --  INITIALIZE THE WAVENUMBER COORDINATES
C -----------------------------------------------------------------------
      DO 50 I=1,NX
      IF(I-NNX)30,30,40
   30 KX(I)=(I-1)*DKX
      GO TO 50
   40 KX(I)=(I-NX-1)*DKX
   50 CONTINUE
      DO 90 J=1,NY
      IF(J-NNY)60,60,70
   60 KY(J)=(J-1)*DKY
      GO TO 80
   70 KY(J)=(J-NY-1)*DKY
   80 CONTINUE
      SKY=KY(J)**2
      DO 90 I=1,NX
      IJ=INDEX(I,J,NY)
      K(IJ)=SQRT(KX(I)**2+SKY)
   90 CONTINUE
C -----------------------------------------------------------------------
C --  FIND MAXIMA AND MINIMA OF ZTOP AND ZBOT ARRAYS; FIXUP BAD VALUES
C OF ZTOP AND ZBOT
C -----------------------------------------------------------------------
      ZTPMAX=-.1E20
      ZTPMIN= .1E20
      ZBTMAX=-.1E20
      ZBTMIN= .1E20
      NERR1=0
      NERR2=0
      DO 120 I=1,NTOTAL
      IF(ZTOP(I).GT.(ZH+EPSLON))GO TO 100
      NERR2=NERR2+1
      ZTOP(I)=ZH+EPSLON
  100 CONTINUE
      IF(ZTOP(I).LT.ZBOT(I))GO TO 110
      ZBOT(I)=ZTOP(I)
      NERR1=NERR1+1
  110 CONTINUE
      ZTPMAX=AMAX1(ZTPMAX,ZTOP(I))
      ZTPMIN=AMIN1(ZTPMIN,ZTOP(I))
      ZBTMAX=AMAX1(ZBTMAX,ZBOT(I))
      ZBTMIN=AMIN1(ZBTMIN,ZBOT(I))
  120 CONTINUE
      IF(NERR1.GT.0)WRITE(LUTERM,130)NERR1
      IF(NERR1.GT.0)WRITE(LULIST,130)NERR1
  130 FORMAT(/,' **WARNING  - THE BODY HAS NEGATIVE THICKNESS AT ',
     &I6,/,'               POINTS.  BODY WILL HAVE ZERO THICKNESS',
     &/,'               AT THESE LOCATIONS.'/)
      IF(NERR2.GT.0)WRITE(LUTERM,140)NERR2
      IF(NERR2.GT.0)WRITE(LULIST,140)NERR2
  140 FORMAT(/,' **WARNING  - THE BODY RISES ABOVE SURVEY'
     &' ELEVATION AT ',I6,/,
     &'               POINTS.  BODY WILL BE TRUNCATED'
     &' ACCORDINGLY.'/)
C -----------------------------------------------------------------------
C --  FIND MEDIAN VALUES FOR ZTOP AND ZBOT; DETERMINE IF EITHER ARE FLAT
C -----------------------------------------------------------------------
      IFLTTP=0
      IFLTBT=0
      IF(ZTPMAX.EQ.ZTPMIN)IFLTTP=1
      IF(ZBTMAX.EQ.ZBTMIN)IFLTBT=1
      ZTPMED=ZTPMIN+(ZTPMAX-ZTPMIN)/2.
      ZBTMED=ZBTMIN+(ZBTMAX-ZBTMIN)/2.
      WRITE(LUTERM,150)ZTPMIN,ZTPMAX,ZTPMED,ZBTMIN,ZBTMAX,ZBTMED
      WRITE(LULIST,150)ZTPMIN,ZTPMAX,ZTPMED,ZBTMIN,ZBTMAX,ZBTMED
  150 FORMAT(/,' THE HIGH, LOW, AND MEDIAN POINTS OF THE'
     &' TOPOGRAPHY ARE ',//,
     &3G11.4,///,' THE HIGH, LOW, AND MEDIAN POINTS OF THE BOTTOM',
     &' SURFACE ARE ',//,3G11.4/)
C -----------------------------------------------------------------------
C --  COMPUTE THE 5 COEFFICIENTS FOR THE PHASE FUNCTION PHI
C -----------------------------------------------------------------------
      MX=COS(SINCL*CONV)*COS((SDECL-AZIM)*CONV)
      MY=COS(SINCL*CONV)*SIN((SDECL-AZIM)*CONV)
      MZ=SIN(SINCL*CONV)
      FX=COS(FINCL*CONV)*COS((FDECL-AZIM)*CONV)
      FY=COS(FINCL*CONV)*SIN((FDECL-AZIM)*CONV)
      FZ=SIN(FINCL*CONV)
      WRITE(LUTERM,160)MX,MY,MZ,FX,FY,FZ
      WRITE(LULIST,160)MX,MY,MZ,FX,FY,FZ
  160 FORMAT(/,' THE COMPONENTS OF MAGNETIZATION AND REGIONAL'
     &' FIELD ARE...',//,
     &5X,'MX = ',F6.3,5X,'MY = ',F6.3,5X,'MZ = ',F6.3,/,
     &5X,'FX = ',F6.3,5X,'FY = ',F6.3,5X,'FZ = ',F6.3/)
      A1=MX*FX-MZ*FZ
      A2=MY*FY-MZ*FZ
      A3=MX*FY+MY*FX
      B1=-MX*FZ-MZ*FX
      B2=-MY*FZ-MZ*FY
C -----------------------------------------------------------------------
C --  FIND THE UPWARD CONTINUATION ARRAYS, ADJUST SURFACES TO MEDIAN LEVELS,
C AND MAKE THE MAGNETIZATION COMPLEX
C -----------------------------------------------------------------------
      IFLAG1=0
      IFLAG2=0
      DO 230 I=1,NTOTAL
      SUM(I)=0.
      ARG1=-K(I)*(ZTPMED-ZH)
      ARG2=-K(I)*(ZBTMED-ZH)
      IF(ARG1+88.028)170,180,180
  170 IFLAG1=IFLAG1+1
      EXPTOP(I)=0.
      GO TO 190
  180 EXPTOP(I)=EXP(ARG1)
  190 CONTINUE
      IF(ARG2+88.028)200,210,210
  200 IFLAG2=IFLAG2+1
      EXPBOT(I)=0.
      GO TO 220
  210 EXPBOT(I)=EXP(ARG2)
  220 CONTINUE
      ZTOP(I)=ZTOP(I)-ZTPMED
      ZBOT(I)=ZBOT(I)-ZBTMED
      FCMPLX(I)=S(I)
  230 CONTINUE
C -----------------------------------------------------------------------
C --  REPORT PROBLEMS WITH UPWARD CONTINUATION
C -----------------------------------------------------------------------
      IF(IFLAG1.GT.0)WRITE(LUTERM,240)IFLAG1
  240 FORMAT(/,' **WARNING - THE UPWARD CONTINUATION'
     &' EXPONENTIAL FOR THE',
     &/,'             UPPER SURFACE UNDERFLOWS '
     &,I6,' TIMES AND THESE'
     &/,'             WILL BE MADE ZERO.'/)
      IF(IFLAG1.GT.0)WRITE(LULIST,240)IFLAG1
      IF(IFLAG2.GT.0)WRITE(LUTERM,250)IFLAG2
  250 FORMAT(/,' **WARNING - THE UPWARD CONTINUATION '
     &' EXPONENTIAL FOR THE',
     &/,'             LOWER SURFACE UNDERFLOWS '
     &,I6,' TIMES AND THESE'
     &/,'             WILL BE MADE ZERO.'/)
      IF(IFLAG2.GT.0)WRITE(LULIST,250)IFLAG2
      IF(IFLAG1.GT.0.OR.IFLAG2.GT.0)WRITE(LUTERM,260)
  260 FORMAT(/,'             TO CORRECT PROBLEM, INCREASE'
     &' SAMPLE INTERVALS.'/)
C -----------------------------------------------------------------------
C --  DO THE N=0 TERM BECAUSE ITS SIMPLE
C -----------------------------------------------------------------------
      CALL FFTSUB(WORK1,WORK2,NX,NY,-1)
      DO 270 I=1,NTOTAL
      HCMPLX(I)=FCMPLX(I)*(EXPBOT(I)-EXPTOP(I))
  270 CONTINUE
C -----------------------------------------------------------------------
C --  GET READY FOR SUMMATION
C -----------------------------------------------------------------------
      WRITE(LUTERM,280)ERR2
      WRITE(LULIST,280)ERR2
  280 FORMAT(/,' PERFORMANCE OF SUMMATION',/,
     &' TRYING TO REACH ',F5.3,' OF STOTAL'/)
      WRITE(LUTERM,290)
      WRITE(LULIST,290)
  290 FORMAT(/,4X,'N',4X,'STOTAL',5X,'SLAST',4X,'SRATIO'/)
C -----------------------------------------------------------------------
C --  BEGIN SUMMATIONS
C -----------------------------------------------------------------------
      N=0
  300 N=N+1
C -----------------------------------------------------------------------
C --  COMBINE UPPER SURFACE WITH MAGNETIZATION AND FOURIER TRANSFORM; IF UPPER
C IS FLAT, SKIP THIS STEP
C -----------------------------------------------------------------------
      IF(IFLTTP.EQ.1)GO TO 330
      DO 310 I=1,NTOTAL
      FCMPLX(I)=S(I)*ZTOP(I)**N
  310 CONTINUE
      CALL FFTSUB(WORK1,WORK2,NX,NY,-1)
C -----------------------------------------------------------------------
C --  MULTIPLY BY UPWARD CONTINUATION ARRAY
C -----------------------------------------------------------------------
      DO 320 I=1,NTOTAL
      SUM(I)=-EXPTOP(I)*FCMPLX(I)
  320 CONTINUE
  330 CONTINUE
C -----------------------------------------------------------------------
C --  COMBINE LOWER SURFACE WITH MAGNETIZATION AND FOURIER TRANSFORM; IF LOWER
C SURFACE IS FLAT, SKIP THIS STEP
C -----------------------------------------------------------------------
      IF(IFLTBT.EQ.1)GO TO 360
      DO 340 I=1,NTOTAL
      FCMPLX(I)=S(I)*ZBOT(I)**N
  340 CONTINUE
      CALL FFTSUB(WORK1,WORK2,NX,NY,-1)
C -----------------------------------------------------------------------
C --  MULTIPLY BY UPWARD CONTINUATION ARRAY AND ADD TO PREVIOUS RESULT FOR
C UPPER SURFACE
C -----------------------------------------------------------------------
      DO 350 I=1,NTOTAL
      SUM(I)=EXPBOT(I)*FCMPLX(I)+SUM(I)
  350 CONTINUE
  360 CONTINUE
C -----------------------------------------------------------------------
C --  MULTIPLY THIS TERM BY -K**N/N! AND FIND ITS CONTRIBUTION; FIND THE
C CONTRIBUTION OF THE SUM OF ALL PREVIOUS TERMS; ADD THE NEW TERM
C -----------------------------------------------------------------------
      SLAST=0.
      STOTAL=0.
      DO 370 I=1,NTOTAL
      ARG=((-K(I))**N)*FACT(N)
      SUM(I)=ARG*SUM(I)
      SLAST=SLAST+CABS(SUM(I))
      STOTAL=STOTAL+CABS(HCMPLX(I))
      HCMPLX(I)=HCMPLX(I)+SUM(I)
  370 CONTINUE
      SLAST=SLAST/NTOTAL
      STOTAL=STOTAL/NTOTAL
      STEST=ERR2*STOTAL
      SRATIO=SLAST/(STOTAL+.1E-20)
C -----------------------------------------------------------------------
C --  CHECK FOR CONVERGENCE OF SUM
C -----------------------------------------------------------------------
      WRITE(LUTERM,380)N,STOTAL,SLAST,SRATIO
      WRITE(LULIST,380)N,STOTAL,SLAST,SRATIO
  380 FORMAT(I5,3G10.3)
      IF(N.LT.NSTOP.AND.SLAST.GE.STEST)GO TO 300
C -----------------------------------------------------------------------
C --  SUMMATION HAS CONVERGED; PHASE SHIFT AND INVERSE FOURIER TRANSFORM
C -----------------------------------------------------------------------
      DO 390 J=1,NY
      KY2=KY(J)**2
      DO 390 I=1,NX
      IJ=INDEX(I,J,NY)
      IF(IJ.EQ.1)GO TO 390
      KX2=KX(I)**2
      K2=KX2+KY2
      PHIR=(A1*KX2+A2*KY2+A3*KX(I)*KY(J))/K2
      PHII=(B1*KX(I)+B2*KY(J))/K(IJ)
      PHI=CMPLX(PHIR,PHII)
      FCMPLX(IJ)=HCMPLX(IJ)*PHI*TWOPI
  390 CONTINUE
      FCMPLX(1)=0.
      CALL FFTSUB(WORK1,WORK2,NX,NY,1)
C -----------------------------------------------------------------------
C --  PUT REAL PART OF COMPLEX ANOMALY BACK INTO REAL ARRAY
C -----------------------------------------------------------------------
      ARG=(10.**5)/NTOTAL
      DO 400 I=1,NTOTAL
      H(I)=FCMPLX(I)*ARG
  400 CONTINUE
C -----------------------------------------------------------------------
C --  UNAUGMENT THE ARRAYS
C -----------------------------------------------------------------------
      IF(NAUGX.EQ.0.AND.NAUGY.EQ.0)GO TO 410
      NX=NX-NAUGX
      NY=NY-NAUGY
      CALL AUGMENT(H,NY,NX,NAUGY,NAUGX,0)
  410 CONTINUE
      RETURN
      END
      FUNCTION FAC(N,IER)
C -----------------------------------------------------------------------
C FUNCTION FAC FINDS THE FACTORIAL OF N
C -----------------------------------------------------------------------
      IER=0
      IF(N.GT.1)GO TO 20
      IF(N.GE.0)GO TO 10
      IER=1
   10 FAC=1.
      RETURN
   20 FAC=N
      FAC2=FAC
   30 FAC2=FAC2-1.
      IF(FAC2.EQ.1.)RETURN
      FAC=FAC*FAC2
      GO TO 30
      END
      SUBROUTINE AUGMENT(F,NCOL,NROW,NAUGCOL,NAUGROW,IADD)
      DIMENSION F(6400)
      COMMON /INTER5/TEMP(6400)
C -----------------------------------------------------------------------
C SUBROUTINE AUGMENT ADDS OR SUBTRACTS NAUGCOL COLUMNS AND NAUGROW
C ROWS TO OR FROM ARRAY F.  IF IADD=1, THE NEW ARRAY F HAS DIMENSIONS
C (NCOL+NAUGCOL) X (NROW+NAUGROW) AND THE NEW
C VALUES ADDED TO F ARE CALCULATED TO BE STRAIGHT-LINE SLOPES SO AS TO
C MAKE F PERIODIC.  FOR EXAMPLE, IF F(2,1)=4, F(2,NROW)=0, AND NAUGROW=3, THEN
C F(2,NROW+1)=3, F(2,NROW+2)=2, AND F(2,NROW+3)=1.
C IF IADD=0, SUBROUTINE AUGMENT TAKES AN ARRAY F OF DIMENSIONS
C (NCOL+NAUGCOL) X (NROW+NAUGROW) AND STRIPS OFF THE LAST NAUGCOL COLUMNS
C AND NAUGROW ROWS TO LEAVE F WITH DIMENSIONS NCOL X NROW.
C -----------------------------------------------------------------------
      INDEX(I,J,N)=(I-1)*N+J
      NRP1=NROW+1
      NCP1=NCOL+1
      NRPNA=NROW+NAUGROW
      NCPNA=NCOL+NAUGCOL
      IF(IADD.EQ.0)GO TO 70
      DO 30 I=1,NROW
      IJ1=INDEX(I,1,NCOL)
      IJ2=INDEX(I,NCOL,NCOL)
      DISCON=(F(IJ2)-F(IJ1))/(NAUGCOL+1)
      DO 10 J=1,NCOL
      IJ3=INDEX(I,J,NCOL)
      IJ4=INDEX(I,J,NCPNA)
   10 TEMP(IJ4)=F(IJ3)
      DO 20 J=NCP1,NCPNA
      IJ4=INDEX(I,J,NCPNA)
   20 TEMP(IJ4)=F(IJ2)-DISCON*(J-NCOL)
   30 CONTINUE
      DO 50 J=1,NCPNA
      IJ1=INDEX(1,J,NCPNA)
      IJ2=INDEX(NROW,J,NCPNA)
      DISCON=(TEMP(IJ2)-TEMP(IJ1))/(NAUGROW+1)
      DO 40 I=NRP1,NRPNA
      IJ=INDEX(I,J,NCPNA)
   40 TEMP(IJ)=TEMP(IJ2)-DISCON*(I-NROW)
   50 CONTINUE
      DO 60 I=1,NRPNA
      DO 60 J=1,NCPNA
      IJ=INDEX(I,J,NCPNA)
   60 F(IJ)=TEMP(IJ)
      RETURN
C
   70 CONTINUE
      DO 80 I=1,NROW
      DO 80 J=1,NCOL
      IJ1=INDEX(I,J,NCOL)
      IJ2=INDEX(I,J,NCPNA)
   80 TEMP(IJ1)=F(IJ2)
      DO 90 I=1,NROW
      DO 90 J=1,NCOL
      IJ=INDEX(I,J,NCOL)
   90 F(IJ)=TEMP(IJ)
      RETURN
      END
      SUBROUTINE FFTSUB(WORK1,WORK2,NX,NY,ISIGN)
      DIMENSION WORK1(NY,NX),WORK2(NY,NX)
      COMMON /INTER3/FCMPLX(6400)
      COMPLEX FCMPLX,CMPLX
C -----------------------------------------------------------------------
C --     THIS ROUTINE SPLITS A COMPLEX ARRAY FCMPLX INTO ITS REAL AND
C IMAGINARY PARTS, CALLS SINGLETON'S SUBROUTINE FFT, AND PUTS THE
C RESULTS BACK INTO FCMPLX
C -----------------------------------------------------------------------
      INDEX(I,J,N)=(I-1)*N+J
      NTOTAL=NX*NY
      DO 10 I=1,NX
      DO 10 J=1,NY
      IJ=INDEX(I,J,NY)
      WORK1(J,I)=REAL(FCMPLX(IJ))
      WORK2(J,I)=AIMAG(FCMPLX(IJ))
   10 CONTINUE
      CALL FFT(WORK1,WORK2,NTOTAL,NY,NY,ISIGN)
      CALL FFT(WORK1,WORK2,NTOTAL,NX,NTOTAL,ISIGN)
      DO 20 I=1,NX
      DO 20 J=1,NY
      IJ=INDEX(I,J,NY)
      FCMPLX(IJ)=CMPLX(WORK1(J,I),WORK2(J,I))
   20 CONTINUE
      RETURN
      END
      SUBROUTINE FFT(A,B,NTOT,N,NSPAN,ISN)
C -----------------------------------------------------------------------
C ********************* START OF FFT *************************
C UP TO 2/4/73
C ** FOR REAL DATA, USE TOGETHER WITH REALTR, A SEPARATE ROUTINE
C -SEE REALTR FOR DETAILS
C ** DOES NOT RUN UNDER WATFIV
C ** AS AN EXAMPLE OF HOW TO CALL THIS PROGRAM,  A TEST DRIVER
C IS AVAILABLE IN A SEPARATE LIBRARY
C MULTIVARIATE COMPLEX FOURIER TRANSFORM, COMPUTED IN PLACE
C USING MIXED-RADIX FAST FOURIER TRANSFORM ALGORITHM.
C BY R. C. SINGLETON, STANFORD RESEARCH INSTITUTE, SEPT. 1968
C ARRAYS A AND B ORIGINALLY HOLD THE REAL AND IMAGINARY
C COMPONENTS OF THE DATA, AND RETURN THE REAL AND
C IMAGINARY COMPONENTS OF THE RESULTING FOURIER COEFFICIENTS.
C MULTIVARIATE DATA IS INDEXED ACCORDING TO THE FORTRAN
C ARRAY ELEMENT SUCCESSOR FUNCTION, WITHOUT LIMIT
C ON THE NUMBER OF IMPLIED MULTIPLE SUBSCRIPTS.
C THE SUBROUTINE IS CALLED ONCE FOR EACH VARIATE.
C THE CALLS FOR A MULTIVARIATE TRANSFORM MAY BE IN ANY ORDER.
C NTOT IS THE TOTAL NUMBER OF COMPLEX DATA VALUES.
C N IS THE DIMENSION OF THE CURRENT VARIABLE.
C NSPAN/N IS THE SPACING OF CONSECUTIVE DATA VALUES
C WHILE INDEXING THE CURRENT VARIABLE.
C THE SIGN OF ISN DETERMINES THE SIGN OF THE COMPLEX
C EXPONENTIAL, AND THE MAGNITUDE OF ISN IS NORMALLY ONE.
C A TRI-VARIATE TRANSFORM WITH A(N1,N2,N3), B(N1,N2,N3)
C IS COMPUTED BY
C CALL FFT(A,B,N1*N2*N3,N1,N1,1)
C CALL FFT(A,B,N1*N2*N3,N2,N1*N2,1)
C CALL FFT(A,B,N1*N2*N3,N3,N1*N2*N3,1)
C FOR A SINGLE-VARIATE TRANSFORM,
C NTOT = N = NSPAN = (NUMBER OF COMPLEX DATA VALUES), E.G.
C CALL FFT(A,B,N,N,N,1)
C THE DATA CAN ALTERNATIVELY BE STORED IN A SINGLE COMPLEX ARRAY C
C IN STANDARD FORTRAN FASHION, I.E., ALTERNATING REAL AND
C IMAGINARY PARTS.  THEN WITH MOST FORTRAN COMPILERS, THE
C COMPLEX ARRAY C CAN BE EQUIVALENCED TO A REAL ARRAY A, THE
C MAGNITUDE OF ISN CHANGED TO TWO TO GIVE THE CORRECT INDEXING
C INCREMENT, AND A AND A(2) USED TO PASS THE INITIAL ADDRESSES
C FOR THE SEQUENCES OF REAL AND IMAGINARY VALUES, E.G.,
C COMPLEX C(NTOT)
C REAL A(2*NTOT)
C EQUIVALENCE (C(1),A(1))
C CALL FFT(A,A(2),NTOT,N,NSPAN,2)
C ARRAYS AT(MAXF), CK(MAXF), BT(MAXF), SK(MAXF), AND NP(MAXP)
C ARE USED FOR TEMPORARY STORAGE.  IF THE AVAILABLE STORAGE
C IS INSUFFICIENT, THE PROGRAM IS TERMINATED BY A STOP.
C MAXF MUST BE .GE. THE MAXIMUM PRIME FACTOR OF N.
C MAXP MUST BE .GT. THE NUMBER OF PRIME FACTORS OF N.
C IN ADDITION, IF THE SQUARE-FREE PORTION K OF N HAS TWO OR
C MORE PRIME FACTORS, THEN MAXP MUST BE .GE. K-1.
C -----------------------------------------------------------------------
      DIMENSION A(1),B(1)
C -----------------------------------------------------------------------
C ARRAY STORAGE IN NFAC FOR A MAXIMUM OF 15 PRIME FACTORS OF N.
C IF N HAS MORE THAN ONE SQUARE-FREE FACTOR, THE PRODUCT OF THE
C SQUARE-FREE FACTORS MUST BE .LE. 210
C -----------------------------------------------------------------------
      DIMENSION NFAC(11),NP(209)
C -----------------------------------------------------------------------
C ARRAY STORAGE FOR MAXIMUM PRIME FACTOR OF 91
C -----------------------------------------------------------------------
      DIMENSION AT(91),CK(91),BT(91),SK(91)
      EQUIVALENCE (I,II)
C -----------------------------------------------------------------------
C THE FOLLOWING TWO CONSTANTS SHOULD AGREE WITH THE ARRAY DIMENSIONS.
C -----------------------------------------------------------------------
      MAXF=91
      MAXP=209
      IF(N .LT. 2) RETURN
      INC=ISN
      C72=0.30901699437494742D0
      S72=0.95105651629515357D0
      S120=0.86602540378443865D0
      RAD=6.2831853071796D0
      IF(ISN .GE. 0) GO TO 10
      S72=-S72
      S120=-S120
      RAD=-RAD
      INC=-INC
   10 NT=INC*NTOT
      KS=INC*NSPAN
      KSPAN=KS
      NN=NT-INC
      JC=KS/N
      RADF=RAD*FLOAT(JC)*0.5
      I=0
      JF=0
C -----------------------------------------------------------------------
C DETERMINE THE FACTORS OF N
C -----------------------------------------------------------------------
      M=0
      K=N
      GO TO 30
   20 M=M+1
      NFAC(M)=4
      K=K/16
   30 IF(K-(K/16)*16 .EQ. 0) GO TO 20
      J=3
      JJ=9
      GO TO 50
   40 M=M+1
      NFAC(M)=J
      K=K/JJ
   50 IF(MOD(K,JJ) .EQ. 0) GO TO 40
      J=J+2
      JJ=J**2
      IF(JJ .LE. K) GO TO 50
      IF(K .GT. 4) GO TO 60
      KT=M
      NFAC(M+1)=K
      IF(K .NE. 1) M=M+1
      GO TO 100
   60 IF(K-(K/4)*4 .NE. 0) GO TO 70
      M=M+1
      NFAC(M)=2
      K=K/4
   70 KT=M
      J=2
   80 IF(MOD(K,J) .NE. 0) GO TO 90
      M=M+1
      NFAC(M)=J
      K=K/J
   90 J=((J+1)/2)*2+1
      IF(J .LE. K) GO TO 80
  100 IF(KT .EQ. 0) GO TO 120
      J=KT
  110 M=M+1
      NFAC(M)=NFAC(J)
      J=J-1
      IF(J .NE. 0) GO TO 110
C -----------------------------------------------------------------------
C COMPUTE FOURIER TRANSFORM
C -----------------------------------------------------------------------
  120 SD=RADF/FLOAT(KSPAN)
      CD=2.0*SIN(SD)**2
      SD=SIN(SD+SD)
      KK=1
      I=I+1
      IF(NFAC(I) .NE. 2) GO TO 170
C -----------------------------------------------------------------------
C TRANSFORM FOR FACTOR OF 2 (INCLUDING ROTATION FACTOR)
C -----------------------------------------------------------------------
      KSPAN=KSPAN/2
      K1=KSPAN+2
  130 K2=KK+KSPAN
      AK=A(K2)
      BK=B(K2)
      A(K2)=A(KK)-AK
      B(K2)=B(KK)-BK
      A(KK)=A(KK)+AK
      B(KK)=B(KK)+BK
      KK=K2+KSPAN
      IF(KK .LE. NN) GO TO 130
      KK=KK-NN
      IF(KK .LE. JC) GO TO 130
      IF(KK .GT. KSPAN) GO TO 360
  140 C1=1.0-CD
      S1=SD
  150 K2=KK+KSPAN
      AK=A(KK)-A(K2)
      BK=B(KK)-B(K2)
      A(KK)=A(KK)+A(K2)
      B(KK)=B(KK)+B(K2)
      A(K2)=C1*AK-S1*BK
      B(K2)=S1*AK+C1*BK
      KK=K2+KSPAN
      IF(KK .LT. NT) GO TO 150
      K2=KK-NT
      C1=-C1
      KK=K1-K2
      IF(KK .GT. K2) GO TO 150
      AK=C1-(CD*C1+SD*S1)
      S1=(SD*C1-CD*S1)+S1
      C1=2.0-(AK**2+S1**2)
      S1=C1*S1
      C1=C1*AK
      KK=KK+JC
      IF(KK .LT. K2) GO TO 150
      K1=K1+INC+INC
      KK=(K1-KSPAN)/2+JC
      IF(KK .LE. JC+JC) GO TO 140
      GO TO 120
C -----------------------------------------------------------------------
C TRANSFORM FOR FACTOR OF 3 (OPTIONAL CODE)
C -----------------------------------------------------------------------
  160 K1=KK+KSPAN
      K2=K1+KSPAN
      AK=A(KK)
      BK=B(KK)
      AJ=A(K1)+A(K2)
      BJ=B(K1)+B(K2)
      A(KK)=AK+AJ
      B(KK)=BK+BJ
      AK=-0.5*AJ+AK
      BK=-0.5*BJ+BK
      AJ=(A(K1)-A(K2))*S120
      BJ=(B(K1)-B(K2))*S120
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      KK=K2+KSPAN
      IF(KK .LT. NN) GO TO 160
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 160
      GO TO 320
C -----------------------------------------------------------------------
C TRANSFORM FOR FACTOR OF 4
C -----------------------------------------------------------------------
  170 IF(NFAC(I) .NE. 4) GO TO 260
      KSPNN=KSPAN
      KSPAN=KSPAN/4
  180 C1=1.0
      S1=0
  190 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      AKP=A(KK)+A(K2)
      AKM=A(KK)-A(K2)
      AJP=A(K1)+A(K3)
      AJM=A(K1)-A(K3)
      A(KK)=AKP+AJP
      AJP=AKP-AJP
      BKP=B(KK)+B(K2)
      BKM=B(KK)-B(K2)
      BJP=B(K1)+B(K3)
      BJM=B(K1)-B(K3)
      B(KK)=BKP+BJP
      BJP=BKP-BJP
      IF(ISN .LT. 0) GO TO 220
      AKP=AKM-BJM
      AKM=AKM+BJM
      BKP=BKM+AJM
      BKM=BKM-AJM
      IF(S1 .EQ. 0) GO TO 230
  200 A(K1)=AKP*C1-BKP*S1
      B(K1)=AKP*S1+BKP*C1
      A(K2)=AJP*C2-BJP*S2
      B(K2)=AJP*S2+BJP*C2
      A(K3)=AKM*C3-BKM*S3
      B(K3)=AKM*S3+BKM*C3
      KK=K3+KSPAN
      IF(KK .LE. NT) GO TO 190
  210 C2=C1-(CD*C1+SD*S1)
      S1=(SD*C1-CD*S1)+S1
      C1=2.0-(C2**2+S1**2)
      S1=C1*S1
      C1=C1*C2
      C2=C1**2-S1**2
      S2=2.0*C1*S1
      C3=C2*C1-S2*S1
      S3=C2*S1+S2*C1
      KK=KK-NT+JC
      IF(KK .LE. KSPAN) GO TO 190
      KK=KK-KSPAN+INC
      IF(KK .LE. JC) GO TO 180
      IF(KSPAN .EQ. JC) GO TO 360
      GO TO 120
  220 AKP=AKM+BJM
      AKM=AKM-BJM
      BKP=BKM-AJM
      BKM=BKM+AJM
      IF(S1 .NE. 0) GO TO 200
  230 A(K1)=AKP
      B(K1)=BKP
      A(K2)=AJP
      B(K2)=BJP
      A(K3)=AKM
      B(K3)=BKM
      KK=K3+KSPAN
      IF(KK .LE. NT) GO TO 190
      GO TO 210
C -----------------------------------------------------------------------
C TRANSFORM FOR FACTOR OF 5 (OPTIONAL CODE)
C -----------------------------------------------------------------------
  240 C2=C72**2-S72**2
      S2=2.0*C72*S72
  250 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      K4=K3+KSPAN
      AKP=A(K1)+A(K4)
      AKM=A(K1)-A(K4)
      BKP=B(K1)+B(K4)
      BKM=B(K1)-B(K4)
      AJP=A(K2)+A(K3)
      AJM=A(K2)-A(K3)
      BJP=B(K2)+B(K3)
      BJM=B(K2)-B(K3)
      AA=A(KK)
      BB=B(KK)
      A(KK)=AA+AKP+AJP
      B(KK)=BB+BKP+BJP
      AK=AKP*C72+AJP*C2+AA
      BK=BKP*C72+BJP*C2+BB
      AJ=AKM*S72+AJM*S2
      BJ=BKM*S72+BJM*S2
      A(K1)=AK-BJ
      A(K4)=AK+BJ
      B(K1)=BK+AJ
      B(K4)=BK-AJ
      AK=AKP*C2+AJP*C72+AA
      BK=BKP*C2+BJP*C72+BB
      AJ=AKM*S2-AJM*S72
      BJ=BKM*S2-BJM*S72
      A(K2)=AK-BJ
      A(K3)=AK+BJ
      B(K2)=BK+AJ
      B(K3)=BK-AJ
      KK=K4+KSPAN
      IF(KK .LT. NN) GO TO 250
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 250
      GO TO 320
C -----------------------------------------------------------------------
C TRANSFORM FOR ODD FACTORS
C -----------------------------------------------------------------------
  260 K=NFAC(I)
      KSPNN=KSPAN
      KSPAN=KSPAN/K
      IF(K .EQ. 3) GO TO 160
      IF(K .EQ. 5) GO TO 240
      IF(K .EQ. JF) GO TO 280
      JF=K
      S1=RAD/FLOAT(K)
      C1=COS(S1)
      S1=SIN(S1)
      IF(JF .GT. MAXF) GO TO 590
      CK(JF)=1.0
      SK(JF)=0.0
      J=1
  270 CK(J)=CK(K)*C1+SK(K)*S1
      SK(J)=CK(K)*S1-SK(K)*C1
      K=K-1
      CK(K)=CK(J)
      SK(K)=-SK(J)
      J=J+1
      IF(J .LT. K) GO TO 270
  280 K1=KK
      K2=KK+KSPNN
      AA=A(KK)
      BB=B(KK)
      AK=AA
      BK=BB
      J=1
      K1=K1+KSPAN
  290 K2=K2-KSPAN
      J=J+1
      AT(J)=A(K1)+A(K2)
      AK=AT(J)+AK
      BT(J)=B(K1)+B(K2)
      BK=BT(J)+BK
      J=J+1
      AT(J)=A(K1)-A(K2)
      BT(J)=B(K1)-B(K2)
      K1=K1+KSPAN
      IF(K1 .LT. K2) GO TO 290
      A(KK)=AK
      B(KK)=BK
      K1=KK
      K2=KK+KSPNN
      J=1
  300 K1=K1+KSPAN
      K2=K2-KSPAN
      JJ=J
      AK=AA
      BK=BB
      AJ=0.0
      BJ=0.0
      K=1
  310 K=K+1
      AK=AT(K)*CK(JJ)+AK
      BK=BT(K)*CK(JJ)+BK
      K=K+1
      AJ=AT(K)*SK(JJ)+AJ
      BJ=BT(K)*SK(JJ)+BJ
      JJ=JJ+J
      IF(JJ .GT. JF) JJ=JJ-JF
      IF(K .LT. JF) GO TO 310
      K=JF-J
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      J=J+1
      IF(J .LT. K) GO TO 300
      KK=KK+KSPNN
      IF(KK .LE. NN) GO TO 280
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 280
C -----------------------------------------------------------------------
C MULTIPLY BY ROTATION FACTOR (EXCEPT FOR FACTORS OF 2 AND 4)
C -----------------------------------------------------------------------
  320 IF(I .EQ. M) GO TO 360
      KK=JC+1
  330 C2=1.0-CD
      S1=SD
  340 C1=C2
      S2=S1
      KK=KK+KSPAN
  350 AK=A(KK)
      A(KK)=C2*AK-S2*B(KK)
      B(KK)=S2*AK+C2*B(KK)
      KK=KK+KSPNN
      IF(KK .LE. NT) GO TO 350
      AK=S1*S2
      S2=S1*C2+C1*S2
      C2=C1*C2-AK
      KK=KK-NT+KSPAN
      IF(KK .LE. KSPNN) GO TO 350
      C2=C1-(CD*C1+SD*S1)
      S1=S1+(SD*C1-CD*S1)
      C1=2.0-(C2**2+S1**2)
      S1=C1*S1
      C2=C1*C2
      KK=KK-KSPNN+JC
      IF(KK .LE. KSPAN) GO TO 340
      KK=KK-KSPAN+JC+INC
      IF(KK .LE. JC+JC) GO TO 330
      GO TO 120
C -----------------------------------------------------------------------
C PERMUTE THE RESULTS TO NORMAL ORDER---DONE IN TWO STAGES
C PERMUTATION FOR SQUARE FACTORS OF N
C -----------------------------------------------------------------------
  360 NP(1)=KS
      IF(KT .EQ. 0) GO TO 450
      K=KT+KT+1
      IF(M .LT. K) K=K-1
      J=1
      NP(K+1)=JC
  370 NP(J+1)=NP(J)/NFAC(J)
      NP(K)=NP(K+1)*NFAC(J)
      J=J+1
      K=K-1
      IF(J .LT. K) GO TO 370
      K3=NP(K+1)
      KSPAN=NP(2)
      KK=JC+1
      K2=KSPAN+1
      J=1
      IF(N .NE. NTOT) GO TO 410
C -----------------------------------------------------------------------
C PERMUTATION FOR SINGLE-VARIATE TRANSFORM (OPTIONAL CODE)
C -----------------------------------------------------------------------
  380 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 380
  390 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2 .GT. NP(J)) GO TO 390
      J=1
  400 IF(KK .LT. K2) GO TO 380
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 400
      IF(KK .LT. KS) GO TO 390
      JC=K3
      GO TO 450
C -----------------------------------------------------------------------
C PERMUTATION FOR MULTIVARIATE TRANSFORM
C -----------------------------------------------------------------------
  410 K=KK+JC
  420 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=K2+INC
      IF(KK .LT. K) GO TO 420
      KK=KK+KS-JC
      K2=K2+KS-JC
      IF(KK .LT. NT) GO TO 410
      K2=K2-NT+KSPAN
      KK=KK-NT+JC
      IF(K2 .LT. KS) GO TO 410
  430 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2 .GT. NP(J)) GO TO 430
      J=1
  440 IF(KK .LT. K2) GO TO 410
      KK=KK+JC
      K2=KSPAN+K2
      IF(K2 .LT. KS) GO TO 440
      IF(KK .LT. KS) GO TO 430
      JC=K3
  450 IF(2*KT+1 .GE. M) RETURN
      KSPNN=NP(KT+1)
C -----------------------------------------------------------------------
C PERMUTATION FOR SQUARE-FREE FACTORS OF N
C -----------------------------------------------------------------------
      J=M-KT
      NFAC(J+1)=1
  460 NFAC(J)=NFAC(J)*NFAC(J+1)
      J=J-1
      IF(J .NE. KT) GO TO 460
      KT=KT+1
      NN=NFAC(KT)-1
      IF(NN .GT. MAXP) GO TO 590
      JJ=0
      J=0
      GO TO 490
  470 JJ=JJ-K2
      K2=KK
      K=K+1
      KK=NFAC(K)
  480 JJ=KK+JJ
      IF(JJ .GE. K2) GO TO 470
      NP(J)=JJ
  490 K2=NFAC(KT)
      K=KT+1
      KK=NFAC(K)
      J=J+1
      IF(J .LE. NN) GO TO 480
C -----------------------------------------------------------------------
C DETERMINE THE PERMUTATION CYCLES OF LENGTH GREATER THAN 1
C -----------------------------------------------------------------------
      J=0
      GO TO 510
  500 K=KK
      KK=NP(K)
      NP(K)=-KK
      IF(KK .NE. J) GO TO 500
      K3=KK
  510 J=J+1
      KK=NP(J)
      IF(KK .LT. 0) GO TO 510
      IF(KK .NE. J) GO TO 500
      NP(J)=-J
      IF(J .NE. NN) GO TO 510
      MAXF=INC*MAXF
C -----------------------------------------------------------------------
C REORDER A AND B, FOLLOWING THE PERMUTATION CYCLES
C -----------------------------------------------------------------------
      GO TO 580
  520 J=J-1
      IF(NP(J) .LT. 0) GO TO 520
      JJ=JC
  530 KSPAN=JJ
      IF(JJ .GT. MAXF) KSPAN=MAXF
      JJ=JJ-KSPAN
      K=NP(J)
      KK=JC*K+II+JJ
      K1=KK+KSPAN
      K2=0
  540 K2=K2+1
      AT(K2)=A(K1)
      BT(K2)=B(K1)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 540
  550 K1=KK+KSPAN
      K2=K1-JC*(K+NP(K))
      K=-NP(K)
  560 A(K1)=A(K2)
      B(K1)=B(K2)
      K1=K1-INC
      K2=K2-INC
      IF(K1 .NE. KK) GO TO 560
      KK=K2
      IF(K .NE. J) GO TO 550
      K1=KK+KSPAN
      K2=0
  570 K2=K2+1
      A(K1)=AT(K2)
      B(K1)=BT(K2)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 570
      IF(JJ .NE. 0) GO TO 530
      IF(J .NE. 1) GO TO 520
  580 J=K3+1
      NT=NT-KSPNN
      II=NT-INC+1
      IF(NT .GE. 0) GO TO 520
      RETURN
C -----------------------------------------------------------------------
C ERROR FINISH, INSUFFICIENT ARRAY STORAGE
C -----------------------------------------------------------------------
  590 ISN=0
      WRITE(*,600)
      STOP
  600 FORMAT(44H0ARRAY BOUNDS EXCEEDED WITHIN SUBROUTINE FFT)
      END
